-- Vital 2.1
{-
By default, data structures are displayed textually. For example:
-}
-- LOCN 25 150 true
-- STYLE comment
--
nat = [0 ..]
--
-- LOCN 50 200 true
-- STYLE 
--
nat
--
-- LOCN 50 425 true
-- STYLE list2
--
import SS

--
-- LOCN 675 25 true
-- STYLE 
{-
The way that values are displayed is determined by the 'style' associated with their definition.
For example, the above list may instead be displayed as a sequence of boxed values:
-}
-- LOCN 25 375 true
-- STYLE comment
{-
(Use the mouse or the scroll bar to drag this document sideways to explore more of this list . . .)
-}
-- LOCN 25 275 true
-- STYLE comment
--
improve x = 0.5 * (2.0 / x + x)
--
-- LOCN 50 1175 true
-- STYLE Hide
{-
A list can be displayed vertically (using the 'vList' style function):
-}
-- LOCN 25 1125 true
-- STYLE comment
{-
. . . and so a list of lists, such as:
-}
-- LOCN 25 1500 true
-- STYLE comment
--
products = [map (* n) [1 .. n] | n <- nat]
--
-- LOCN 50 1550 true
-- STYLE 
{-
. . . can be displayed as a table:
-}
-- LOCN 25 1650 true
-- STYLE comment
--
products
--
-- LOCN 25 1725 true
-- STYLE table2
{-
Styles for lists and tables
-}
-- LOCN 25 50 true
-- STYLE title
--
nat
--
-- LOCN 50 575 true
-- STYLE blueList
{-
. . . or it may may be displayed as a linked data structure with the constructor (:), the
the head and the tail of each element explicitly shown:
-}
-- LOCN 25 525 true
-- STYLE comment
--
root2 = take 8 $ iterate improve 1.0
--
-- LOCN 50 1225 true
-- STYLE list' (Box 180 18 brown black) (Format SansSerif 16 white False False)
{-
Clicking on the "handle" (the small square) of an item (a declaration, expression or comment)
causes its definition and style to be displayed in the Edit Panel at the top of this window.
-}
-- LOCN 25 675 true
-- STYLE comment
{-
Styles are ordinary Haskell values (of a predefined datatype 'Style').

The styles used in this document (such as 'blueList' or 'comment4')are defined in the 'SS1' 
module (imported at the head of this document). For example, the style used to display the following 
list of Unicode characters is defined using an 'enlarge' function to modify an existing style:
-}
-- LOCN 25 800 true
-- STYLE comment
{-
Two-dimensional displays
-}
-- LOCN 25 1050 true
-- STYLE heading1
--
map chr [600 ..]
--
-- LOCN 50 925 true
-- STYLE enlarge list2
{-
Return to previous document
-}
-- LOCN 525 1725 true
-- STYLE open ""
{-
Return to previous document
-}
-- LOCN 675 75 true
-- STYLE open ""
{-
Exercise!
Click on the handles of some of
the above items to see the styles 
they use.
-}
-- LOCN 700 675 true
-- STYLE commentB
{-
Example: sorted powersets
-}
-- LOCN 525 1675 true
-- STYLE open "Powersets"
{-
Illustrates the notion of a "style" and illustrates typical styles
for one and two dimensional data structures.
-}
-- LOCN 25 -50 true
-- STYLE abstract
