-- Vital 2.1
{-
Styles for user-defined data types
-}
-- LOCN 50 50 true
-- STYLE title
--
import SS
--
-- LOCN 775 50 true
-- STYLE 
--
data Tree = Tip Int
          | Tree :+: Tree
--
-- LOCN 75 175 true
-- STYLE Hide
--
tree n = (Tip (n+1) :+: (Tip n :+: tree (n+5))) :+: Tip (n+2)
--
-- LOCN 75 300 true
-- STYLE Hide
--
t = tree 0
--
-- LOCN 75 425 true
-- STYLE 
--
t
--
-- LOCN 250 650 true
-- STYLE yellowTree'
--
t
--
-- LOCN 550 725 true
-- STYLE blueTree
{-
Styles may be defined for any container type to allow its values to be
displayed diagrammatically. For example, consider binary trees:
-}
-- LOCN 50 125 true
-- STYLE comment
{-
Here is a typical tree-building function:
-}
-- LOCN 50 250 true
-- STYLE comment
{-
. . . and here is a typical tree built using that function. By default,
values are displayed textually:
-}
-- LOCN 50 350 true
-- STYLE comment
{-
Here is the same value, displayed using two alternative styles:
 - a vertical style, with the constructors explicitly shown,
 - a horizontal style, with the constructors not shown.
-}
-- LOCN 50 550 true
-- STYLE comment
{-
More on styles: (an example of a style 
for displaying continued fractions)
-}
-- LOCN 700 550 true
-- STYLE open "Demo6"
{-
Back to previous page
-}
-- LOCN 700 600 true
-- STYLE open ""
{-
Back to previous document
-}
-- LOCN 775 100 true
-- STYLE open ""
{-
Demonstrates the use of the "yellowTree"  and "blueTree" styles for displaying
values of a Tree datatype.
-}
-- LOCN 50 -50 true
-- STYLE abstract
