-- Vital 2.1
{-
Direct Manipulation
-}
-- LOCN 50 50 true
-- STYLE title
--
import SS
--
-- LOCN 675 50 true
-- STYLE 
--
tr = Tip 10 :+: (Tip 20 :+: Tip 30)
--
-- LOCN 100 1150 true
-- STYLE blueTree'
--
p = [map (* n) [1 .. n] | n <- [1 .. 5]]
--
-- LOCN 75 800 true
-- STYLE table box2 fmt3
--
ns = [1 .. 5]
--
-- LOCN 75 350 true
-- STYLE blueList
{-
More on Direct Manipulation
-}
-- LOCN 675 1175 true
-- STYLE open "Demo3"
--
sum (map sum p)
--
-- LOCN 575 800 true
-- STYLE 
--
data Tree = Tip Int | Tree :+: Tree
--
-- LOCN 100 1125 true
-- STYLE Hide
{-
A Vital document is 'live' in the sense that the data structures displayed may
be manipulated (using Copy and Paste operations) and the Haskell source
code will be updated to reflect any changes.
-}
-- LOCN 50 125 true
-- STYLE comment
{-
For example, try the following operations on the list ns shown below:
 - double-click in the field containing the value '4'
 - press the Copy button on the toolbar
 - double-click in the field containing the value '2'
 - press the Paste button.
-}
-- LOCN 50 225 true
-- STYLE comment
{-
. . . and then (on the same list):
 - double-click in the tail of the leftmost cell, and press the Copy button
 - double-click in the tail of one of the other cells, and press the Paste button.
-}
-- LOCN 50 450 true
-- STYLE comment
{-
Similar operations may be carried out on other (finite) data structures. If the chosen style
displays the 'links' between data-carrying elements, then both the form of the structure 
and the contents of the individual elements can be changed. But if (as in the triangular
structure below) the links are hidden, then the form of the container is immutable.

Try these operations on this array:
 - double-click in any element
 - type an integer-valued expression (eg, 2+2) into the 'Item' field in the top of the window
 - hold down the SHIFT key and press the Paste button
This will paste that value into the selected cell.

-}
-- LOCN 50 550 true
-- STYLE comment
{-
(Press the 'Undo' button in the toolbar to undo any changes.)
-}
-- LOCN 50 950 true
-- STYLE comment
{-
Similar operations can be performed on Tree values. For example:
 - Double-click in the right-hand field of the root node and press the Copy key
 - Double-click in the right-hand field of the daughter node and press the Paste key
-}
-- LOCN 50 1025 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 675 1225 true
-- STYLE open ""
{-
Back to previous document
-}
-- LOCN 675 75 true
-- STYLE open ""
{-
An explanation of how to carry out Direct Manipulation
on values of concrete datatypes.
-}
-- LOCN 50 -50 true
-- STYLE abstract
