-- Vital 2.1
{-
Pictures and Images
-}
-- LOCN 25 50 true
-- STYLE title
--
import SS
--
-- LOCN 725 50 true
-- STYLE 
--
duke  = imageFile "duke.gif"
--
-- LOCN 675 1250 true
-- STYLE Hide
--
pics = let colours = [black, blue, green, cyan, red, magenta, yellow, gray, white] 
       in [Rect 10 10 x black | x <- colours]
--
-- LOCN 50 650 true
-- STYLE Hide
--
pic = Ellipse 80 40 yellow red `Super` Line 80 40 blue
--
-- LOCN 50 175 true
-- STYLE defaultStyle
--
array = let sizes = [30, 40 .. 80] 
        in [[PicImage (scaleImage w h duke) | w <- sizes] | h <- sizes]
--
-- LOCN 50 1450 true
-- STYLE bareTable 80 80 Picture
{-
More about Pictures
-}
-- LOCN 650 900 true
-- STYLE open "Demo5"
{-
More about Images
-}
-- LOCN 700 1975 true
-- STYLE open "Demo4"
--
curry = imageFile "people/curry.jpg"
--
-- LOCN 675 1225 true
-- STYLE Hide
--
PicImage curry
--
-- LOCN 176 1143 true
-- STYLE Picture
--
PicImage duke
--
-- LOCN 400 1150 true
-- STYLE Picture
--
cycle' xs = cycle (xs ++ reverse xs)
--
-- LOCN 50 2100 true
-- STYLE Hide
--
cycle' $ map cycle' array
--
-- LOCN 50 2150 true
-- STYLE bareTable 80 80 Picture
{-
Images
-}
-- LOCN 50 1000 true
-- STYLE heading1
{-
A collection of datatypes (Pic, Color, Font, etc.) and definitions for representing pictures is
provided and, using these, values representing pictures may be constructed. For example:
-}
-- LOCN 50 125 true
-- STYLE comment
{-
Such values may be displayed as actual pictures by using the Picture style:
-}
-- LOCN 50 300 true
-- STYLE comment
--
pic
--
-- LOCN 50 325 true
-- STYLE Picture
{-
(The picture dataypes are defined in a library module named 'Pic' that is automatically imported (along with
the Prelude) by every module. To see this module, use the 'Window' button (on the menu bar at the top of 
this window) to select the 'Pic' module. Afterwards, return to this module by selecting module 'A4' from
the same menu.)
-}
-- LOCN 50 450 true
-- STYLE comment
{-
Styles may be defined for displaying data structures that contain 'Pic' values. For
example, this list of pictures:
-}
-- LOCN 50 575 true
-- STYLE comment
{-
. . . could be displayed in forms such as these:
-}
-- LOCN 50 725 true
-- STYLE comment
--
pics
--
-- LOCN 250 775 true
-- STYLE bareList 50 10 Picture
--
pics
--
-- LOCN 50 775 true
-- STYLE bareList' 10 10 Picture
{-
Bit-mapped images (in the form of .gif and .jpeg files) may read in and (using the 'Picture' style)
displayed.  For example:
-}
-- LOCN 50 1050 true
-- STYLE comment
{-
(Vital is based on Haskell, named after the logician Haskell Curry. It is implemented in Java, here
 represented by its 'Duke' icon [TM, Sun Microsystems Inc.].)
-}
-- LOCN 175 1325 true
-- STYLE comment
{-
Images may be manipulated and styles may be defined for displaying images contained
in data structures. For example:
-}
-- LOCN 50 1400 true
-- STYLE comment
{-
The declarative nature of Haskell coupled with the efficiency of the JVM allow quite
large data structures to be depicted:
-}
-- LOCN 50 2050 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 700 2075 true
-- STYLE open1 ""
{-
Back to previous document
-}
-- LOCN 725 75 true
-- STYLE open ""
{-
More about elementary pictures
-}
-- LOCN 650 850 true
-- STYLE open "Pic1"
{-
Tutorial exposition of picture functions
-}
-- LOCN 650 950 true
-- STYLE open1 "PictureWork"
{-
Illustrating how pictures may be constructed (in terms of the 'Pic'
datatype) and how pictures and images (.gif, .jpeg) may be displayed.
-}
-- LOCN 25 -50 true
-- STYLE abstract
{-
Tessellation using an image
-}
-- LOCN 700 2025 true
-- STYLE open "Tessellation"
