-- Vital 2.1
--
import SS


--
-- LOCN 700 50 true
-- STYLE 
{-
Barcharts
-}
-- LOCN 50 75 true
-- STYLE title
{-
The library module "Barchart.hs" defines a collection of functions for generating barchart pictures:
-}
-- LOCN 50 150 true
-- STYLE comment
--
import Barchart
--
-- LOCN 75 200 true
-- STYLE 
--
blueBar = plainBar blue white
--
-- LOCN 75 1075 true
-- STYLE Hide
--
redYellowBar = solidBar red yellow magenta 
--
-- LOCN 75 1775 true
-- STYLE Hide
--
barChart blueBar 100 100 "1999-2004" companyV
--
-- LOCN 75 1325 true
-- STYLE Picture
--
barChart redYellowBar 400 100 "1999 - 2004" companyV

--
-- LOCN 75 1900 true
-- STYLE Picture
--
multiBarChart 800 200 chartTitle prices











--
-- LOCN 75 2600 true
-- STYLE Picture
--
chartTitle = "Prices of five companies in the IT/Telecoms sector, 1999 - 2004"
--
-- LOCN 75 2450 true
-- STYLE Hide
{-
To create a simple bar chart, first a function for displaying a single bar is created by specialising
the "plainBar" function with two colours (one for the body, the other for the edge). For example:
-}
-- LOCN 50 1000 true
-- STYLE comment
{-
This imports these functions:
    plainBar :: Color -> Color -> Int -> Int -> Int -> Pic
    solidBar :: Color -> Color -> Color -> Int -> Int -> Int -> Pic
    barChart :: (Int -> Int -> Int -> Pic) -> Int -> Int -> String -> [Int] -> Pic
    multiBarChart :: Int -> Int -> String -> [[Int]] -> Pic
-}
-- LOCN 275 200 true
-- STYLE commentM
{-
The barChart function takes as arguments:     
     - a bar function (such as the one above);
     - the desired lengths of the X and Y axes;
     - a title for the chart;
     - a list of data values.

and it yields a picture value. For example:
-}
-- LOCN 50 1150 true
-- STYLE comment
{-
To illustrate these functions, we import some share price data (for
five IT/Telecoms companies over the period 1999 to 2004) from 
the DataInput document:
-}
-- LOCN 50 350 true
-- STYLE comment
--
import DataInput
--
-- LOCN 75 425 true
-- STYLE 
{-
For example, the share prices (normalised wrt the mean) of two of the companies during this period were:
-}
-- LOCN 50 700 true
-- STYLE comment
{-
A bar chart with a 3-D look can be obtained simply by creating a "solid" bar function. For example:
-}
-- LOCN 50 1725 true
-- STYLE comment
{-
3-D effect barcharts
-}
-- LOCN 50 1650 true
-- STYLE heading1
{-
. . . and using this function in place of the plain one used above. For example:
-}
-- LOCN 50 1850 true
-- STYLE comment
{-
Multiple-series barcharts
-}
-- LOCN 50 2175 true
-- STYLE heading1
{-
The "multiBarChart" function creates barcharts with multiple data series. It takes
as arguments:
  - the desired lengths of the X and Y axes;
  - a title for the chart;
  - a list of lists of data values
-}
-- LOCN 50 2250 true
-- STYLE comment
{-
For example, using the data in the earlier "prices" table, and supplying the title:
-}
-- LOCN 50 2400 true
-- STYLE comment
{-
. . . the function yields the following barchart
-}
-- LOCN 50 2525 true
-- STYLE comment
--
blueBar 20 40 60

--
-- LOCN 525 1075 true
-- STYLE Picture
--
barChart (plainBar gray black)300 200 "Company A" companyA
--
-- LOCN 500 1325 true
-- STYLE Picture
{-
More about the barchart functions
-}
-- LOCN 75 3125 true
-- STYLE open "Pic2"
{-
Barcharts and the prime numbers
-}
-- LOCN 75 3175 true
-- STYLE open "Pic3"
{-
Back to previous document
-}
-- LOCN 75 3225 true
-- STYLE open1 ""
--
prices
--
-- LOCN 75 500 true
-- STYLE table2
--
companyA = prices !! 0
--
-- LOCN 100 750 true
-- STYLE 
--
companyV = prices !! 4
--
-- LOCN 100 825 true
-- STYLE 
{-
The "DataInput" document
-}
-- LOCN 700 350 true
-- STYLE open1 "DataInput"
{-
Back to previous document
-}
-- LOCN 700 75 true
-- STYLE open1 ""
{-
Illustrates how the functions defined in the 'Barchart' library module may be used
to display barcharts (incl. multi-series barcharts).  This document (indirectly)
uses the 'textFile' function to read in data from file and parsing combinators
(from the 'Parse' library) to parse the data.
-}
-- LOCN 50 -100 true
-- STYLE abstract
