-- Vital 2.1
{-
The 8 Queens problem
-}
-- LOCN 50 75 true
-- STYLE title
--
import SS
--
-- LOCN 825 75 true
-- STYLE 
--
import Chess
--
-- LOCN 50 250 true
-- STYLE 
--
diagrams 4
--
-- LOCN 75 700 true
-- STYLE Picture
{-
The "8-Queens" problem asks whether 8 queens can be placed on a chessboard
in such a way that no queen threatens any other. Its generalisation is
the n-queens problem.
-}
-- LOCN 50 150 true
-- STYLE comment
{-
The "Chess" library module defines functions

      queens :: Int -> [[Int]]

      diagrams :: Int -> Pic

that describe and depict the set of solutions to the "n-Queens" problem
-}
-- LOCN 50 300 true
-- STYLE comment
{-
Applying the "diagrams" function to the first few integers shows that there is a single solution for 
a 1 x 1 chessboard(!), no solutions for 2 x 2 or 3 x 3 chessboards, and two solutions
for a 4 x 4 chessboard:
-}
-- LOCN 50 500 true
-- STYLE comment
--
diagrams 1
--
-- LOCN 75 600 true
-- STYLE Picture
--
diagrams 2
--
-- LOCN 375 600 true
-- STYLE Picture
--
diagrams 3
--
-- LOCN 675 600 true
-- STYLE Picture
--
diagrams 8
--
-- LOCN 75 1075 true
-- STYLE Picture
--
diagrams 12
--
-- LOCN 75 1475 true
-- STYLE Picture
{-
For an 8 x 8 chessboard, there are some 92 solutions:
-}
-- LOCN 50 1025 true
-- STYLE comment
{-
Alternatively, using the "queens" function, the set of solutions can be shown as
a list. For example:
-}
-- LOCN 50 850 true
-- STYLE comment
--
queens 4
--
-- LOCN 75 925 true
-- STYLE 
{-
For larger chess boards, there tend to be large numbers of solutions. For example, the
set of solutions for a 12 x 12 chess board is:
-}
-- LOCN 50 1400 true
-- STYLE comment
{-
Depending on the speed of your computer, there may
be several seconds delay in evaluating the following
expressions . . .
-}
-- LOCN 625 925 true
-- STYLE warning2
{-
Back to previous document
-}
-- LOCN 50 1800 true
-- STYLE open1 ""
{-
Back to previous document
-}
-- LOCN 700 275 true
-- STYLE open1 ""
{-
More about the n-queens algorithm
-}
-- LOCN 700 225 true
-- STYLE open "PictureWork5"
{-
More about displaying chess boards
-}
-- LOCN 700 175 true
-- STYLE open "PictureWork4"
{-
The "Chess.hs" library module ( * )
-}
-- LOCN 700 350 true
-- STYLE openLib "Chess"
{-
*  Use the "Back" button on 
   the toolbar to return
   from this module.
-}
-- LOCN 700 400 true
-- STYLE comment
{-
Scroll sideways (or drag using the mouse) to see
all of these solutions.
-}
-- LOCN 625 1300 true
-- STYLE comment
{-
Illustrates the use of the 'Chess' library module to diplay chess positions
and to enumerate solutions to the n-queens problem.
-}
-- LOCN 50 -50 true
-- STYLE abstract
