-- Vital 2.1
{-
Continued fractions
-}
-- LOCN 50 75 true
-- STYLE title
--
import SS
--
-- LOCN 675 50 true
-- STYLE 
{-
Specialised styles may be defined for particular applications. For example, 
suppose that continued fraction are to be represented by lists then a specialised
style can be defined to allow an end-user to display a list as a continued fraction.

The module CFrac contains a style-constructing function
    cFracStyle :: Color -> Style
that builds a continued-fraction style
-}
-- LOCN 50 150 true
-- STYLE comment
--
import CFrac
--
-- LOCN 75 325 true
-- STYLE 
--
cf = 1 : replicate 10 2
--
-- LOCN 75 500 true
-- STYLE redStyle
--
eval ns = 
  case ns of {
    [] -> 1.0;
    m:ms  -> fromInt m + (1.0 / eval ms)
  }
--
-- LOCN 75 775 true
-- STYLE Hide
--
eval cf
--
-- LOCN 75 875 true
-- STYLE 
--
redStyle = cFracStyle red
--
-- LOCN 75 350 false
-- STYLE 
{-
Using this style, a list can be displayed as a continued fraction and its elements
edited using Copy and Paste operations
-}
-- LOCN 50 425 true
-- STYLE comment
{-
The value represented by this continued fraction
(which tends towards the square root of 2) is given by:
-}
-- LOCN 50 725 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 500 900 true
-- STYLE open ""
{-
Exercise!
- Double-click on one of the 2's in the continued fraction to select that field;
- Type some expression (eg, "3 * 4") into the "Item" field at the top of the window;
- While holding down the Shift key, press the "Paste" button in the toolbar.

Notice how the original Haskell declaration for "cf" has been modified to incorporate
the inserted expression.

Press the "Undo" button to undo the change.
-}
-- LOCN 50 975 true
-- STYLE commentB
{-
Illustrates a style for displaying continued fractions.
-}
-- LOCN 50 -50 true
-- STYLE abstract
{-
Back to previous document
-}
-- LOCN 675 100 true
-- STYLE open ""
