-- Vital 2.1
{-
A generic display class
-}
-- LOCN 50 50 true
-- STYLE title
--
instance Display () where 
  display x = Rect 10 10 blue black
--
-- LOCN 51 206 true
-- STYLE 
--
display ()
--
-- LOCN 667 202 true
-- STYLE Picture
--
instance Display Char where 
  display c = let { box = Rect 15 15 white black;
                    fmt = Format SansSerif 12 red False False;
                    ch  = PicText fmt [c]}
               in Super box (Trans 5 12 ch)
 
--
-- LOCN 50 300 true
-- STYLE 
--
display 'x'
--
-- LOCN 675 300 true
-- STYLE Picture
--
instance Display Int where 
  display n = let { fmt = Format SansSerif 12 red False False; 
                    num = show n;                   
                    s  = PicText fmt num;
                    box = Rect (8 * length num + 5) 15 white black}
               in Super box (Trans 5 12 s)
--
-- LOCN 50 425 true
-- STYLE 
--
display 1
--
-- LOCN 683 419 true
-- STYLE Picture
--
display 123456789
--
-- LOCN 812 414 true
-- STYLE Picture
--
display (-123)
--
-- LOCN 685 512 true
-- STYLE Picture
--
instance Display Double where 
  display d = let { fmt = Format SansSerif 12 red False False; 
                    num = show d;                   
                    s  = PicText fmt num;
                    box = Rect (8 * length num + 5) 15 white black}
               in Super box (Trans 5 12 s)
--
-- LOCN 50 625 true
-- STYLE 
--
display pi
--
-- LOCN 689 632 true
-- STYLE Picture
--
instance (Display a) => Display [a] where
  display xs = case xs of {
                  []   -> NoPic;
                  y:ys -> display y `Super` Trans 30 0 (display ys)
               }
--
-- LOCN 58 798 true
-- STYLE 
--
display [1 .. 5]
--
-- LOCN 696 789 true
-- STYLE Picture
--
instance (Display a, Display b) => Display (a,b) where
  display p = let { pic1 = display (fst p);
                    pic2 = display (snd p)
              } in pic1 `Super` Trans 0 15 pic2
--
-- LOCN 56 927 true
-- STYLE 
--
display (12345, pi)
--
-- LOCN 698 918 true
-- STYLE Picture
--
instance Display (a -> b) where
  display f = let {box = Rect 60 15 white black;
                   fmt = Format Serif 12 blue False False;
                   p   = PicText fmt "<function>"
              } in Super box (Trans 5 12 p)
--
-- LOCN 50 1050 true
-- STYLE 
--
display (*)
--
-- LOCN 705 1033 true
-- STYLE Picture
--
instance Display Bool where
  display b = let vs = if b then
                         [(5,15), (8,18), (18,5), (8,18)]
                       else
                         [(5,5), (18,18), (12,12), (5,18), (18,5), (12,12)]
               in Poly vs white black
--
-- LOCN 51 1184 true
-- STYLE 
--
display True
--
-- LOCN 705 1178 true
-- STYLE Picture
--
display False
--
-- LOCN 865 1178 true
-- STYLE Picture
--
instance (Display a) => Display (Maybe a) where 
  display x = case x of {
                Nothing -> NoPic;
                Just x  -> display x
              }
--
-- LOCN 51 1340 true
-- STYLE 
--
display Nothing
--
-- LOCN 706 1325 true
-- STYLE Picture
--
display (Just pi)
--
-- LOCN 873 1325 true
-- STYLE Picture
--
class Display a where
  display :: a -> Pic
--
-- LOCN 49 124 true
-- STYLE 
--
import SS
--
-- LOCN 675 50 true
-- STYLE 
{-
A sketch of how a "Display" class might be defined. It provides a method, "display", that
is analogous to the "show" method of the standard "Show" class.
-}
-- LOCN 50 -50 true
-- STYLE abstract
