-- Vital 2.1
--
import SS
--
-- LOCN 575 575 true
-- STYLE 
{-
Interaction
-}
-- LOCN 25 50 true
-- STYLE title
{-
The picture constructor:
        Interaction :: State -> FSM -> Pic
allows an interactive simulation to be created from the
definition of a finite-state machine and its initial state.
-}
-- LOCN 25 100 true
-- STYLE comment
{-
For example, here is an interactive simulation of a simple
game. The aim of the game is to keep the "blob" away from
the rapacious "dots". 
  - the blob can be moved around by pulling on it with
    the elastic cord attached to the mouse cursor;
  - the dots bounce around autonomously with 
    ever-increasing vigour.
-}
-- LOCN 25 200 true
-- STYLE comment
{-
To play the game:
  - move the mouse around to guide the blob;
  - click with the mouse to escape through hyperspace
    to a new position;
  - click with the mouse anywhere above the top of the
    game panel to start a new game.
-}
-- LOCN 25 400 true
-- STYLE comment
{-
An explanation of how this program works
-}
-- LOCN 100 675 true
-- STYLE open "DotGame1"
--
import DotGameLib
--
-- LOCN 600 675 true
-- STYLE 
--
Interaction initState game
--
-- LOCN 500 75 true
-- STYLE Picture
{-
Back to previous document
-}
-- LOCN 100 725 true
-- STYLE open1 ""
{-
Back to previous document
-}
-- LOCN 54 1269 true
-- STYLE open ""
{-
More about interaction:
-}
-- LOCN 25 575 true
-- STYLE commentB
{-
(As usual, press the Animate button 
 to animate the display.)
-}
-- LOCN 100 350 true
-- STYLE warning2
{-
Principles of interaction
-}
-- LOCN 100 625 true
-- STYLE open "Interaction"
{-
Back to previous document
-}
-- LOCN 625 25 true
-- STYLE open ""
{-
The top-level function "game", used in the above
simulation, is defined in the library module "DotGameLib".
-}
-- LOCN 575 625 true
-- STYLE comment
{-
The module "DotGameLib"
-}
-- LOCN 600 725 true
-- STYLE openLib "DotGameLib"
{-
A simple game (keeping a blob on an elastic cord away from a
set of autonomous moving dots) that uses the "Interaction" picture
constructor is demonstrated.
-}
-- LOCN 25 -75 true
-- STYLE abstract
