-- Vital 2.1
--
import SS
--
-- LOCN 650 50 true
-- STYLE 
{-
The Edit Class
-}
-- LOCN 50 50 true
-- STYLE title
--
boolToPic :: Bool -> Pic
--
-- LOCN 50 175 true
-- STYLE 
--
boolToPic b =
  let {color = if b then cyan else yellow;
       sq1 = Rect s3 s3 trans gray;
       sq2 = SelRect s1 s1 color black
  } in sq1 `Super` Trans s1 s1 sq2
--
-- LOCN 50 200 true
-- STYLE Hide
--
s1 = 20
--
-- LOCN 650 150 true
-- STYLE Hide
--
s3 = 3 * s1
--
-- LOCN 650 175 true
-- STYLE Hide
--
boolToPic True
--
-- LOCN 50 350 true
-- STYLE Picture
--
boolToPic False
--
-- LOCN 225 350 true
-- STYLE Picture
--
boolsToPic :: [Bool] -> Pic
--
-- LOCN 51 501 true
-- STYLE 
--
boolsToPic bs = foldr f NoPic bs
--
-- LOCN 50 550 true
-- STYLE Hide
--
f b pic = (boolToPic b) `Super` (Trans s3 0 pic)
--
-- LOCN 50 575 true
-- STYLE Hide
--
boolsToPic [True, False, True, True]
--
-- LOCN 50 625 true
-- STYLE Picture
--
data Board = Board [Bool]
--
-- LOCN 50 750 true
-- STYLE 
--
boardToPic board = 
  case board of
    Board bs -> boolsToPic bs
                
--
-- LOCN 50 950 true
-- STYLE Hide
--
replicate 5 True
--
-- LOCN 560 719 true
-- STYLE 
--
theBoard = mkBoard 5
--
-- LOCN 50 1150 true
-- STYLE Hide
--
instance Edit Board where {
  style board = View boardToPic Picture;
  edit board path = 
    [("Set cyan",   setCyanEditFn),
     ("Set yellow", setYellowEditFn),
     ("Show path",  showPathEditFn)]
}
--
-- LOCN 50 1250 true
-- STYLE 
--
showPathEditFn :: EditFn
--
-- LOCN 50 1400 true
-- STYLE 
--
showPathEditFn board path x y lhs rhs clip =
  let message' = show path
  in (Nothing, Nothing, Just message')
--
-- LOCN 50 1425 true
-- STYLE Hide
--
setBoardElem :: Bool -> Int -> Board -> Board
--
-- LOCN 50 2000 true
-- STYLE 
--
setBoardElem b i board =
  let bs = boardToList board
  in Board (setListElem b i bs)
--
-- LOCN 50 2025 true
-- STYLE Hide
--
setListElem :: Bool -> Int -> [Bool] -> [Bool]
--
-- LOCN 50 2150 true
-- STYLE 
--
setListElem b i bs =
  if i == 0 then 
    b : tail bs
  else
    head bs : setListElem b (i-1) (tail bs)
--
-- LOCN 50 2175 true
-- STYLE Hide
--
setListElem False 2 [True, True, True, True]
--
-- LOCN 550 2175 true
-- STYLE 
--
setCyanEditFn board path x y lhs rhs clip =
  let {i = decode path;
       rhs' = "setCyan " ++ show i ++ " (" ++ rhs ++ ")"
  } in (Just rhs', Nothing, Just "OK")
--
-- LOCN 50 1500 true
-- STYLE Hide
--
decodePath :: [Int] -> Int
--
-- LOCN 50 1700 true
-- STYLE 
--
decode path = length path - 2
--
-- LOCN 50 1725 true
-- STYLE Hide
--
boardToList :: Board -> [Bool]
--
-- LOCN 50 825 true
-- STYLE 
--
boardToList board =
  case board of
    Board bs -> bs
--
-- LOCN 50 850 true
-- STYLE Hide
--
mkBoard :: Int -> Board
--
-- LOCN 50 1050 true
-- STYLE 
--
mkBoard n = Board (replicate n False)
--
-- LOCN 50 1075 true
-- STYLE Hide
--
setYellowEditFn board path x y lhs rhs clip =
  let {i = decode path;
       rhs' = "setYellow " ++ show i ++ " (" ++ rhs ++ ")"
  } in (Just rhs', Nothing, Just "OK")
--
-- LOCN 50 1600 true
-- STYLE Hide
{-
(Shown separately for simplicity)
-}
-- LOCN 600 1550 true
-- STYLE comment
--
setCyan, setYellow :: Int -> Board -> Board
--
-- LOCN 50 1875 true
-- STYLE 
--
setCyan = setBoardElem True
  
--
-- LOCN 50 1900 true
-- STYLE Hide
--
setYellow = setBoardElem False
--
-- LOCN 50 1925 true
-- STYLE Hide
--
setCyan 4 (setYellow 3 (setCyan 3 (setYellow 2 (setCyan 1 (mkBoard 5)))))
--
-- LOCN 50 2500 true
-- STYLE 
{-
Test
-}
-- LOCN 50 2450 true
-- STYLE comment
--
setBoardElem True 2 theBoard
--
-- LOCN 525 2000 true
-- STYLE 
--
boardToList theBoard
--
-- LOCN 525 846 true
-- STYLE 
{-
A simple demo of the Edit.style and Edit.edit methods to display a
simple list and change the colour of its elements.
-}
-- LOCN 50 -50 true
-- STYLE abstract
