-- Vital 2.1
--
import SS
--
-- LOCN 875 75 true
-- STYLE 
{-
Demonstration of the FSMlib library module.
-}
-- LOCN 25 75 true
-- STYLE title
--
s0 :: State
--
-- LOCN 25 300 true
-- STYLE 
--
stateToPic :: State -> Pic
--
-- LOCN 25 700 true
-- STYLE 
--
instance Edit (a -> b) where
  style f = Hide
--
-- LOCN 25 1875 true
-- STYLE 
--
displayBool :: Bool -> Pic
--
-- LOCN 25 950 true
-- STYLE 
--
displayBool b =
  let bc = if b then cyan else yellow
  in Rect sqSize sqSize bc black
--
-- LOCN 25 975 true
-- STYLE 
--
sqSize = 50
--
-- LOCN 25 800 true
-- STYLE Hide
--
displayBool True
--
-- LOCN 675 975 true
-- STYLE 
--
displayBool False
--
-- LOCN 800 1025 true
-- STYLE 
--
instance Edit Pic where
  style p = Picture
--
-- LOCN 25 1825 true
-- STYLE 
{-
Supporting code
-}
-- LOCN 25 1775 true
-- STYLE comment
{-
Definition of the decode function
-}
-- LOCN 25 1150 true
-- STYLE heading1
--
decode :: Int -> Int -> Maybe Input
--
-- LOCN 25 1200 true
-- STYLE 
--
decode x y =
  if ((x >= 0) && (x < (sqSize * n)) && (y >= 0) && (y <= sqSize)) then
    Just (x `div` sqSize)
  else
    Nothing
    
--
-- LOCN 25 1225 true
-- STYLE 
--
decode 17 6
--
-- LOCN 750 1250 true
-- STYLE 
{-
High-level FSM
-}
-- LOCN 25 150 true
-- STYLE heading1
--
type State = [Bool]
--
-- LOCN 25 225 true
-- STYLE 
--
n = 16
--
-- LOCN 25 200 true
-- STYLE Hide
--
s0 = replicate n False
--
-- LOCN 25 325 true
-- STYLE Hide
--
s0
--
-- LOCN 650 325 true
-- STYLE 
--
decode 200 6
--
-- LOCN 750 1175 true
-- STYLE 
--
toggleBool i bs 
  = if i == 0 then 
      not (head bs) : tail bs
    else
      head bs : toggleBool (i-1) (tail bs)
--
-- LOCN 25 475 true
-- STYLE 
{-
Click on this image to toggle a bit. (Note: it works equally
well in Eval or in Anim mode.)
-}
-- LOCN 475 1400 true
-- STYLE warning2
--
toggleBool :: Int -> [Bool] -> [Bool]
--
-- LOCN 25 450 true
-- STYLE 
--
fsm :: Input -> State -> State
--
-- LOCN 25 375 true
-- STYLE 
--
fsm = toggleBool
--
-- LOCN 25 400 true
-- STYLE 
--
s1 = fsm 2 s0
--
-- LOCN 650 400 true
-- STYLE 
{-
Definition of the display function
-}
-- LOCN 25 625 true
-- STYLE heading1
--
stateToPic s1
--
-- LOCN 675 675 true
-- STYLE 
--
type Input = Int
--
-- LOCN 25 250 true
-- STYLE 
{-
Test
-}
-- LOCN 25 1375 true
-- STYLE heading1
--
import FSMlib
--
-- LOCN 25 1425 true
-- STYLE 
--
interact s0 fsm decode stateToPic
--
-- LOCN 25 1475 true
-- STYLE 
--
merge = foldr (\p q -> Super p (Trans sqSize 0 q)) NoPic
--
-- LOCN 25 875 true
-- STYLE Hide
--
merge :: [Pic] -> Pic
--
-- LOCN 25 850 true
-- STYLE 
--
stateToPic = merge . (map displayBool)
--
-- LOCN 25 725 true
-- STYLE Hide
{-
(Seems to be similar to the FSM document.)
-}
-- LOCN 25 -50 true
-- STYLE abstract
