-- Vital 2.1
--
import SS
--
-- LOCN 775 125 true
-- STYLE 
{-
Using  FSMlib module to allow toggling squares of a 2-D board game.
-}
-- LOCN 25 75 true
-- STYLE title
--
s0 :: State
--
-- LOCN 25 375 true
-- STYLE 
--
stateToPic :: State -> Pic
--
-- LOCN 25 1075 true
-- STYLE 
--
instance Edit (a -> b) where
  style f = Hide
--
-- LOCN 25 2275 true
-- STYLE 
--
displayBool :: Bool -> Pic
--
-- LOCN 25 1350 true
-- STYLE 
--
displayBool b =
  let bc = if b then cyan else yellow
  in Rect sqSize sqSize bc black
--
-- LOCN 25 1375 true
-- STYLE 
--
sqSize = 20
--
-- LOCN 25 1200 true
-- STYLE Hide
--
displayBool True
--
-- LOCN 675 1375 true
-- STYLE 
--
displayBool False
--
-- LOCN 800 1425 true
-- STYLE 
--
instance Edit Pic where
  style p = Picture
--
-- LOCN 25 2225 true
-- STYLE 
{-
Supporting code
-}
-- LOCN 25 2175 true
-- STYLE comment
{-
Definition of the decode function
-}
-- LOCN 25 1550 true
-- STYLE heading1
--
decode :: Int -> Int -> Maybe Input
--
-- LOCN 25 1600 true
-- STYLE 
--
decode x y =
  if ((x >= 0) && (x < (sqSize * nx)) && (y >= 0) && (y <= (sqSize * ny))) then
    Just ((y `div` sqSize), (x `div` sqSize))
  else
    Nothing
    
--
-- LOCN 25 1625 true
-- STYLE 
--
decode 17 6
--
-- LOCN 750 1650 true
-- STYLE 
{-
High-level FSM
-}
-- LOCN 25 150 true
-- STYLE heading1
--
type State = [[Bool]]
--
-- LOCN 25 275 true
-- STYLE 
--
nx = 6
--
-- LOCN 25 200 true
-- STYLE Hide
--
s0 = replicate ny (replicate nx False)
--
-- LOCN 25 400 true
-- STYLE Hide
--
s0
--
-- LOCN 650 375 true
-- STYLE 
--
decode 200 6
--
-- LOCN 750 1575 true
-- STYLE 
--
toggle ij
  = case ij of
      (i, j) -> update i (update j not)
--
-- LOCN 25 550 true
-- STYLE 
{-
Click on this image to toggle a bit. (Note: it works equally
well in Eval or in Anim mode.)
-}
-- LOCN 475 1800 true
-- STYLE warning2
--
toggle :: (Int, Int) -> [[Bool]] -> [[Bool]]
--
-- LOCN 25 525 true
-- STYLE 
--
fsm :: Input -> State -> State
--
-- LOCN 25 450 true
-- STYLE 
--
fsm = toggle
--
-- LOCN 25 475 true
-- STYLE 
--
s1 = fsm (2, 1) s0
--
-- LOCN 650 525 true
-- STYLE 
{-
Definition of the display function
-}
-- LOCN 25 1025 true
-- STYLE heading1
--
stateToPic s1
--
-- LOCN 650 1075 true
-- STYLE 
--
type Input = (Int, Int)
--
-- LOCN 25 325 true
-- STYLE 
{-
Test
-}
-- LOCN 25 1775 true
-- STYLE heading1
--
import FSMlib
--
-- LOCN 25 1825 true
-- STYLE 
--
interact s0 fsm decode stateToPic
--
-- LOCN 25 1875 true
-- STYLE 
--
merge x y = foldr (\p q -> Super p (Trans x y q)) NoPic
--
-- LOCN 25 1275 true
-- STYLE Hide
--
merge :: Int -> Int -> [Pic] -> Pic
--
-- LOCN 25 1250 true
-- STYLE 
--
ny = 4
--
-- LOCN 25 225 true
-- STYLE Hide
--
update :: Int -> (a -> a) -> [a] -> [a]
--
-- LOCN 25 700 true
-- STYLE 
--
update i f xs =
  if i == 0 then
    f (head xs) : tail xs
  else
    head xs : update (i-1) f (tail xs)
--
-- LOCN 25 725 true
-- STYLE 
--
update 2 (*5) [1..]
--
-- LOCN 650 700 true
-- STYLE 
--
stateToPic bss =
  let pss = map (map displayBool) bss
  in merge 0 sqSize (map (merge sqSize 0) pss)
--
-- LOCN 25 1100 true
-- STYLE 
{-
Note: If the board size is made too large (say 50 x 50), then the time to
render the image is sufficiently long that about half the mouse clicks
are not registered.
-}
-- LOCN 475 1875 true
-- STYLE comment
{-
Demonstrates how to use the FSMlib library module to allow the
user to toggle the colour of the squares of a 2-D board game.
-}
-- LOCN 25 -50 true
-- STYLE abstract
