-- Vital 2.1
--
import SS
--
-- LOCN 775 75 true
-- STYLE 
{-
Hamming sequence
-}
-- LOCN 50 75 true
-- STYLE title
--
merge xs ys =
  case (xs, ys) of 
    (x:xs', y:ys') -> 
      if x == y then
        x : merge xs' ys'
      else if x < y then 
        x : merge xs' ys
      else
        y : merge xs ys'
      
--
-- LOCN 50 175 true
-- STYLE 
{-
Merge two infinite lists
-}
-- LOCN 50 150 true
-- STYLE comment
--
hamming =
  1 : merge
        (map (2 *) hamming)
        (merge
          (map (3 *) hamming)
          (map (5 *) hamming))
--
-- LOCN 50 375 true
-- STYLE 
{-
Collantz sequences
-}
-- LOCN 50 550 true
-- STYLE heading1
--
coll n = 
  let ns = if n == 1
             then []
           else if n `mod` 2 == 0 then
                   coll (n `div` 2)
                else
                   coll (3 * n + 1)
  in n : ns
--
-- LOCN 50 600 true
-- STYLE 
--
coll 2
--
-- LOCN 50 775 true
-- STYLE 
--
coll 3
--
-- LOCN 52 840 true
-- STYLE 
--
coll 4
--
-- LOCN 52 906 true
-- STYLE 
--
coll 5
--
-- LOCN 53 973 true
-- STYLE 
--
coll 6
--
-- LOCN 54 1049 true
-- STYLE 
--
coll 7
--
-- LOCN 54 1124 true
-- STYLE 
--
coll 8
--
-- LOCN 54 1201 true
-- STYLE 
--
coll 9
--
-- LOCN 52 1278 true
-- STYLE 
--
coll 10
--
-- LOCN 56 1353 true
-- STYLE 
--
coll 11
--
-- LOCN 56 1403 true
-- STYLE 
--
coll 12
--
-- LOCN 56 1453 true
-- STYLE 
--
coll 13
--
-- LOCN 56 1503 true
-- STYLE 
--
coll 14
--
-- LOCN 56 1553 true
-- STYLE 
--
coll 15
--
-- LOCN 56 1603 true
-- STYLE 
--
coll 16
--
-- LOCN 56 1653 true
-- STYLE 
--
coll 17
--
-- LOCN 56 1703 true
-- STYLE 
--
coll 18
--
-- LOCN 56 1753 true
-- STYLE 
--
coll 19
--
-- LOCN 56 1803 true
-- STYLE 
--
coll 20
--
-- LOCN 56 1853 true
-- STYLE 
--
coll 21
--
-- LOCN 56 1903 true
-- STYLE 
--
coll 22
--
-- LOCN 56 1953 true
-- STYLE 
--
coll 23
--
-- LOCN 56 2003 true
-- STYLE 
--
coll 119
--
-- LOCN 59 2143 true
-- STYLE 
--
coll 100001
--
-- LOCN 59 2193 true
-- STYLE 
