-- Vital 2.1
{-
g m xs   --> (n, ys)

where
  n   =  number of occurrences of m in xs
  ys  =  the list xs with any instances of m removed
-}
-- LOCN 75 875 true
-- STYLE 
--
g m xs =
    case xs of {
      []    ->  (0, []);
      y:ys  ->  let p = g m ys
                in if y == m then
                      ((1 + fst p), snd p)
                   else
                      (fst p, (y : snd p))
    }
--
-- LOCN 675 875 true
-- STYLE Hide
{-
f m xs  --> n : f (m+1) ys

where
  n    =  number of occurrences of m in xs
  ys   =  the list xs with any instances of m removed
-}
-- LOCN 75 675 true
-- STYLE 
--
f m xs =
    if null xs then
      []
    else
      let p = g m xs
      in fst p : f (m+1) (snd p)
--
-- LOCN 675 675 true
-- STYLE Hide
{-
H I S T O G R A M S
-}
-- LOCN 75 50 true
-- STYLE title
{-
The function
    histogram :: [Int] -> [Int]
represents histograms as lists.  If  ns  is a list of non-negative integers and if
    hs = histogram ns
then the integer at position i in hs represents the number of occurrences of i in
the list ns.

The function is reasonably efficient for lists in which the more frequently occurring
elements occur near the start of the list.
-}
-- LOCN 75 125 true
-- STYLE comment
--
histogram :: [Int] -> [Int]
--
-- LOCN 75 375 true
-- STYLE 
--
histogram ns = f 0 ns
--
-- LOCN 76 427 true
-- STYLE Hide
--
histogram [3, 10, 2, 7, 10, 2, 2, 0, 10, 5]
--
-- LOCN 475 425 true
-- STYLE 
{-
Example:
-}
-- LOCN 475 375 true
-- STYLE 
{-
The function is defined in terms of two subsidiary functions, f and g
-}
-- LOCN 75 575 true
-- STYLE 
{-
Definition of a simple function for computing histograms.
Used by Pic3 (for prime number distribution).
-}
-- LOCN 75 -50 true
-- STYLE abstract
--
import SS
--
-- LOCN 734 40 true
-- STYLE 
