-- Vital 2.1
--
f t = let width = (t `div` 20) `mod` 300
      in Rect width 10 cyan blue
--
-- LOCN 575 725 true
-- STYLE Hide
--
Animation f
--
-- LOCN 575 775 true
-- STYLE Picture
--
initState = 0
--
-- LOCN 25 775 true
-- STYLE Hide
--
fsm t x y m s =
  let {s' = s + (if m then -1 else 1);
       str = "count = " ++ show s;
       pic1 = PicText fmt2 str;
       color = if m then cyan else yellow;
       pic2 = Ellipse x y color blue;
       pic  = axesPic `Super` pic2 `Super` pic1
  } in (s', pic)
--
-- LOCN 25 525 true
-- STYLE Hide
--
Interaction initState fsm


--
-- LOCN 600 150 true
-- STYLE Picture
{-
The 'Interaction' picture constructor
-}
-- LOCN 25 75 true
-- STYLE title
{-
As usual, turn on animation by
pressing the "Anim" button
-}
-- LOCN 575 375 true
-- STYLE warning2
--
import SS
--
-- LOCN 675 25 true
-- STYLE 
{-
The picture constructor:
        Interaction :: State  ->  FSM  ->  Pic
allows interactive pictures to be created from a definition of a finite-state
machine of type:
        Time  ->  Int  ->  Int  ->  Bool  ->  state  ->  (state, Pic)
and its initial state.
-}
-- LOCN 25 150 true
-- STYLE comment
{-
When the Anim mode is turned on, the system invokes the fsm function at
regular intervals, providing it with the following arguments:
  -  the current time (in ms since 1970);
  -  the X and the Y coordinates of the mouse;
  -  a Bool specifying whether or not the mouse button is pressed;
  -  the present state
and the function is required to compute:
  -  the next state;
  -  a picture (in effect, the "output" of the fsm).
-}
-- LOCN 25 300 true
-- STYLE comment
{-
Here is the definition of a simple (contrived!) fsm function:
-}
-- LOCN 25 500 true
-- STYLE comment
--
axesPic = Line 0 100 green `Super` Line 300 0 green
--
-- LOCN 25 675 true
-- STYLE Hide
{-
The simulation both maintains a counter and (when the 
mouse cursor is within the axes) causes an ellipse to
track it. Pressing the mouse button both changes the
colour of the ellipse and reverses the direction in
which the counter counts.
-}
-- LOCN 575 425 true
-- STYLE comment
{-
The state, s, is simply an integer which is counted up or down. Its
initial value is:
-}
-- LOCN 25 725 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 675 75 true
-- STYLE open ""
{-
The "Interaction" picture constructor can be regarded as 
a generalisation of the "Animation" constructor (qv). Here,
for comparision, is a simple example of the latter:
-}
-- LOCN 575 650 true
-- STYLE comment
{-
Comparision of Animation and Interaction
-}
-- LOCN 575 600 true
-- STYLE heading2
{-
Back to previous document
-}
-- LOCN 25 850 true
-- STYLE open ""
{-
A detailed explanation and illustration of the "Interaction" picture
constructor.
-}
-- LOCN 25 -75 true
-- STYLE abstract
