-- Vital 2.1
--
import SS
--
-- LOCN 575 25 true
-- STYLE 
--
import PropLogicLib
--
-- LOCN 580 53 true
-- STYLE 
--
import PropLogicProofLib
--
-- LOCN 580 77 true
-- STYLE 
{-
Test harness for PropLogicProof
-}
-- LOCN 50 50 true
-- STYLE title
--
instance Edit Form where
  style fm = Text 1 defaultFmt
--
-- LOCN 50 121 true
-- STYLE 
--
instance Edit Theorem where
  style thm = Text 1 (Format SansSerif 16 red True False)
--
-- LOCN 49 181 true
-- STYLE 
--
instance Show Either where
  show e = case e of {
             Left x   -> "Left " ++ show x;
             Right y  -> "Right " ++ show y
           }
--
-- LOCN 50 261 true
-- STYLE 
--
prf1 = pp "ImpIntro h: p|q. h"
--
-- LOCN 50 400 true
-- STYLE Hide
--
inf prf1
--
-- LOCN 550 400 true
-- STYLE 
--
prf2 = pp "ImpIntro h1:p. h1"
--
-- LOCN 50 500 true
-- STYLE Hide
--
inf prf2
--
-- LOCN 550 500 true
-- STYLE 
--
prf2a = pp "ImpIntro h1: p. OrIntroR h1 q"
--
-- LOCN 50 600 true
-- STYLE Hide
--
inf prf2a
--
-- LOCN 550 600 true
-- STYLE 
--
prf2b = pp "ImpIntro h2: q. OrIntroL h2 p"
--
-- LOCN 40 697 true
-- STYLE Hide
--
inf prf2b
--
-- LOCN 550 700 true
-- STYLE 
--
prf3 = pp 
"    ImpIntro h: p|q.      \
\      OrElim h of         \
\        Left  h1 -> OrIntroR h1 q     \
\        Right h2 -> OrIntroL h2 p     "
--
-- LOCN 25 825 true
-- STYLE Hide
--
inf prf3
--
-- LOCN 625 825 true
-- STYLE 
--
prf4 = pp
"    ImpIntro h: p | (q & r).                           \
\          (OrElim h of                                 \
\               Left h2  -> OrIntroL h2 q               \
\               Right h2 -> OrIntroR (AndElimL h2) p)   "

--
-- LOCN 35 971 true
-- STYLE Hide
--
inf prf4
--
-- LOCN 650 975 true
-- STYLE 
--
prf5 = pp
"    ImpIntro h: p | (q & r).                           \
\          (OrElim h of                                 \
\               Left h2  -> OrIntroL h2 r               \
\               Right h2 -> OrIntroR (AndElimR h2) p)   "

--
-- LOCN 37 1096 true
-- STYLE Hide
--
inf prf5
--
-- LOCN 650 1100 true
-- STYLE 
--
prf6 = pp
"    ImpIntro h: p | (q & r).                           \
\       AndIntro                                        \
\          (OrElim h of                                 \
\               Left  h2 -> OrIntroL h2 q               \
\               Right h2 -> OrIntroR (AndElimL h2) p)   \
\          (OrElim h of                                 \
\               Left  h2 -> OrIntroL h2 r               \
\               Right h2 -> OrIntroR (AndElimR h2) p)   "
--
-- LOCN 50 1275 true
-- STYLE Hide
--
inf prf6
--
-- LOCN 650 1275 true
-- STYLE 
{-
Distributivity of disjunction over conjunction
-}
-- LOCN 50 1250 true
-- STYLE comment
{-
NB: Some of the following proofs are V E R Y  slow . . .
-}
-- LOCN 550 300 true
-- STYLE warning2
{-
Some simple tests of the PropLogicProofLib library module. Includes proof
of distributivity of disjunction over conjunction. Some of the proofs
are very slow indeed.
-}
-- LOCN 50 -75 true
-- STYLE abstract
