-- Vital 2.1
--
bsp = [[0.0],[1.0,0.0],[2.0,5.0,0.0],[9.0,10.0,5.0,0.0],[13.0,10.0,13.0,4.0,0.0]]

--
-- LOCN 50 25 false
-- STYLE 
--
getDist xss ij = case ij of {(i,j) ->
                   if (i>j) then getDist xss (j, i)
                   else if (i==j) then 0.0
                   else last (take i (last (take (j-1) xss)));
                 otherwise -> 0.0}

--
-- LOCN 50 150 true
-- STYLE 
--
minD xss = let {
                xssIndexed = unlist (map rowIndex (zip xss [2..]));
                x = findMin xssIndexed
               }
            in ((so3 x), (to3 x))

--
-- LOCN 50 250 true
-- STYLE 
--
rowIndex xsi = case xsi of {(xs, i) ->
                 zip3 xs [1..] [i,i..];
               otherwise -> [((0.0),0,0)]}

--
-- LOCN 50 350 true
-- STYLE 
--
unlist yss = case yss of{
                         (xs:[]) -> xs;
                         (xs:xss) -> xs ++ (unlist xss)
                        }

--
-- LOCN 50 425 true
-- STYLE 
--
findMin xs = case xs of{
                        (t:[]) -> t;
                        (t2:ts) -> case t2 of {(t, ti, tj) ->
                                     findMin ([tr | tr <- ts, (fo3 tr) < t] ++ [(t, ti, tj)]);
                                     otherwise -> (0.0,0,0)};
                        otherwise -> (0.0,0,0)
                       }

--
-- LOCN 50 500 true
-- STYLE 
--
fusion xss ij = case ij of {(i,j) ->
                 let {
                       iv = last (take i xss);
                       jv = last (take j xss)
                     }
                 in [fst y | y <- zip xss [1..], ((snd y)/=i) && ((snd y)/=j)] ++ [iv++jv];
               otherwise -> [[0]]}

--
-- LOCN 50 625 true
-- STYLE 
--
cleanedMatrix xss ij = case ij of {(i,j) ->
                        removeEmpty
                          (map (takeCol xss (i,j))
                               [y | y <- [2..((length xss)+1)], (y/=i) && (y/=j)]);
                       otherwise -> [[0.0]]}

--
-- LOCN 50 750 true
-- STYLE 
--
takeCol xss ij c = case ij of {(i,j) ->
                     [fst y | y <- (zip (last (take (c-1) xss)) [1..]),
                                        ((snd y)/=i) && ((snd y)/=j)];
                   otherwise -> [0.0]}

--
-- LOCN 50 850 true
-- STYLE 
--
removeEmpty xss = [y | y <- xss, not (null y)]

--
-- LOCN 50 950 true
-- STYLE 
--
distanceUpdate issxss ij v = case issxss of {(iss,xss) ->
                             case ij of{(i,j) ->
                               let {
                                     mi = length (last (take i iss));
                                     mj = length (last (take j iss))
                                   }
                               in ( (fusion iss (i,j)),
                                      (cleanedMatrix xss (i,j))
                                        ++ [(fusionedColumn iss xss (i,j) mi mj v)] );
                             otherwise -> ([[0]],[[0.0]])};
                           otherwise -> ([[0]],[[0.0]])}

--
-- LOCN 50 1000 true
-- STYLE 
--
fusionedColumn iss xss ij mi mj v = case ij of {(i,j) ->
                                map (dist v iss xss (i,j) mi mj)
                                     [y | y <- [1..((length xss)+1)],
                                                     (y/=i) && (y/=j)];
                              otherwise -> [0.0]}

--
-- LOCN 50 1200 true
-- STYLE 
--
dist v iss xss i_j mi mj r = case i_j of {(i,j) ->
                         let {
                               mrf = fromInt (length (last (take r iss)));
                               ir = getDist xss (i, r);
                               jr = getDist xss (j, r);
                               ij = getDist xss (i, j);
                               mif = fromInt mi;
                               mjf = fromInt mj;
                               alpha_i = getAlpha_i v mif mjf mrf;
                               alpha_j = getAlpha_j v mif mjf mrf;
                               beta = getBeta v mif mjf mrf;
                               gamma = getGamma v
                              }
                          in (alpha_i*ir)
                             + (alpha_j*jr)
                             + (beta*ij)
                             + (gamma*(abs (ir - jr)));
                        otherwise -> 0.0}

--
-- LOCN 50 1325 true
-- STYLE 
--
aggloRec bd v = if (length (fst bd))==1 then [bd]
                else [bd] ++ aggloRec (distanceUpdate bd (minD (snd bd)) v) v

--
-- LOCN 50 1625 true
-- STYLE 
--
agglo bsp 5
--
-- LOCN 50 1750 true
-- STYLE 
--
createIndices len = map mkList [1..(len+1)]
--
-- LOCN 50 75 true
-- STYLE 
--
import M_Util
--
-- LOCN 975 75 true
-- STYLE 
--
mkD d = (createIndices (length d), d)
--
-- LOCN 50 50 true
-- STYLE 
--
agglo d v = aggloRec (mkD (dropDiagonal d)) v

--
-- LOCN 50 1700 true
-- STYLE 
--
mkList n = [n]
--
-- LOCN 50 100 true
-- STYLE 
--
getAlpha_i v mi mj mr = if v<=4 then 1.0/2.0
                        else if v==5 then mi/(mi+mj)
                        else if v==6 then mi/(mi+mj)
                        else (mi+mr)/(mi+mj+mr)

--
-- LOCN 50 1825 true
-- STYLE 
--
getAlpha_j v mi mj mr = if v<=4 then 1.0/2.0
                        else if v==5 then mj/(mi+mj)
                        else if v==6 then mj/(mi+mj)
                        else (mj+mr)/(mi+mj+mr)

--
-- LOCN 50 1925 true
-- STYLE 
--
getBeta v mi mj mr = if ((v<=3) || (v==5)) then 0.0
                        else if v==4 then (-1.0/4.0)
                        else if v==6 then (-(mi*mj)/((mi+mj)^2))
                        else (-mr)/(mi+mj+mr)

--
-- LOCN 50 2025 true
-- STYLE 
--
getGamma v = if v==1 then (-1.0/2.0)
                else if v==2 then 1.0/2.0
                else 0.0

--
-- LOCN 50 2125 true
-- STYLE 
--
dropDiagonal d = map dropLast (drop 1 d)
--
-- LOCN 50 2200 true
-- STYLE 
--
dropLast d = take ((length d)-1) d
--
-- LOCN 50 2250 true
-- STYLE 
{-
M_Util
-}
-- LOCN 875 75 true
-- STYLE open "M_Util"
--
import Styles
--
-- LOCN 975 50 true
-- STYLE 
{-
Zurck zum letzten Dokument
-}
-- LOCN 800 25 true
-- STYLE open ""
