-- Vital 2.1
--
fusionIndex xs ys = case xs of{
                      [] -> 0;
                      (z:zs) -> if (listNotInList z ys) then 1
                                                  else (1 + (fusionIndex zs ys));
                      otherwise -> 0
                    }

--
-- LOCN 50 100 true
-- STYLE 
--
fusionIndices xs ys = let {fstIndex = fusionIndex xs ys}
                        in (fstIndex, fstIndex + (fusionIndex (drop fstIndex xs) ys) )

--
-- LOCN 50 225 true
-- STYLE 
--
divSequence xs = case xs of{
                      (d:[]) -> [];
                      (d:ds) -> (divElem d (head ds)):(divSequence ds)
                 }

--
-- LOCN 50 300 true
-- STYLE 
--
divElem a b = let{xy = fusionIndices (fst a) (fst b)}
              in case xy of {(x,y) ->
                   ((last (take x (fst a))), (last (take y (fst a))),(getDist (snd a) (x,y)));
                   otherwise -> ([0],[0],0.0)}

--
-- LOCN 50 375 true
-- STYLE 
--
divTree xs t = case xs of{
                 [] -> t;
                 (d:ds) -> divTree ds (insert (Div d) t)
               }

--
-- LOCN 50 450 true
-- STYLE 
--
import M_Agglo
--
-- LOCN 950 100 true
-- STYLE 
--
import M_Tree
--
-- LOCN 950 75 true
-- STYLE 
--
buildTree d v = divTree (reverse (divSequence(agglo d v))) Empty

--
-- LOCN 50 525 true
-- STYLE 
--
import M_Util
--
-- LOCN 950 125 true
-- STYLE 
--
printTree bez t x y scaleX scaleY precision = case t of {
                              Node tl (Div (l, r, d)) tr -> let {
                                                                    xl = x-((length l)*scaleX);
                                                                    ylr = y+scaleY;
                                                                    xr = x+((length r)*scaleX)
                                                                  }
                                                            in
                                                            write x y (floatToString d precision)
                                                            # line x y xl y
                                                            # line xl y xl ylr
                                                            # printTree bez tl xl ylr scaleX scaleY precision
                                                            # line x y xr y
                                                            # line xr y xr ylr
                                                            # printTree bez tr xr ylr scaleX scaleY precision;
                              Leaf i -> (write x y (last (take i bez)));
                              Space tn -> line x y x (y+scaleY) # printTree bez tn x (y+scaleY) scaleX scaleY precision
                            }

--
-- LOCN 50 575 true
-- STYLE 
--
import Pic2
--
-- LOCN 950 50 true
-- STYLE 
--
printPhyloTree d v precision = printTree (head d) (buildTree (tail d) v) 0 0 50 50 precision
--
-- LOCN 50 950 true
-- STYLE 
--
printScaledPhyloTree d v scaleX scaleY precision = printTree (head d) (buildTree (tail d) v) 0 0 scaleX scaleY precision
--
-- LOCN 50 1000 true
-- STYLE 
{-
M_Tree
-}
-- LOCN 850 75 true
-- STYLE open "M_Tree"
--
import Styles
--
-- LOCN 950 25 true
-- STYLE 
{-
M_Agglo
-}
-- LOCN 850 100 true
-- STYLE open "M_Agglo"
{-
M_Util
-}
-- LOCN 850 125 true
-- STYLE open "M_Util"
{-
Zurck zum letzten Dokument
-}
-- LOCN 650 25 true
-- STYLE open ""
