-- Vital 2.1
--
r i = case i of
          {
            0 -> 377;
            1 -> 55;
            otherwise -> r(i-2) `mod` r(i-1)
          }
--
-- LOCN 50 175 true
-- STYLE 
--
rs = takeWhile(>0) [r i | i <- [0..] ]
--
-- LOCN 50 300 true
-- STYLE enlarge list2
--
n = length rs - 1
--
-- LOCN 50 375 true
-- STYLE box4 fmt1
--
q i = r(i-1) `div` r i
--
-- LOCN 50 675 true
-- STYLE 
--
qs = [q i | i <- [1 .. n]]
--
-- LOCN 50 725 true
-- STYLE enlarge list2
--
t i = case i of
          {
            0 -> 0;
            1 -> 1;
            otherwise -> t(i-2) - q(i-1) * t(i-1)
          }
--
-- LOCN 50 950 true
-- STYLE 
--
ts = [t i | i <- [0 .. n]]
--
-- LOCN 50 1075 true
-- STYLE enlarge list2
--
import SS

--
-- LOCN 650 50 true
-- STYLE 
{-
Euklidscher Algorithmus
-}
-- LOCN 50 40 true
-- STYLE heading1
--
import Styles
--
-- LOCN 650 25 true
-- STYLE 
{-
Berechne alle Reste ri > 0 der Divisionen 
von r(i-2) durch r(i-1) fuer i = 2,..  
-}
-- LOCN 50 100 true
-- STYLE comment
{-
Berechne Quotienten qi der Divisionen 
von r(i-1) durch ri fuer i = 1,..,n 
-}
-- LOCN 50 600 true
-- STYLE comment
{-
Berechne Folge t0,...,tn mit t0 = 0, t1 = 1 und 
ti = t(i-2) - q(i-1) * t(i-1)  
-}
-- LOCN 50 875 true
-- STYLE comment
{-
Es gilt: 

  ri = ti * r1 (mod r0) fuer alle i=0,..,n 

d.h. tn ist mult. Inverses von r1 modulo r0 
falls rn = 1 
-}
-- LOCN 50 1250 true
-- STYLE 
--
[ ( t i * r 1 ) `mod` r 0 | i <- [0 .. n] ]
--
-- LOCN 50 1475 true
-- STYLE enlarge list2
--
[r i `mod` r 0 | i <- [0 .. n] ]
--
-- LOCN 50 1400 true
-- STYLE enlarge list2
{-
Es gilt ri > 2r(i+2) fuer alle i = 0,...,n-2
(falls r0 > r1)

n ist also logarithmisch in r0
-}
-- LOCN 50 450 true
-- STYLE 
{-
Zurck zum letzten Dokument
-}
-- LOCN 425 25 true
-- STYLE open ""
