-- Vital 2.1
--
trainNeuron xs bias w1 w2 n = let
                              {
                                xsf = pointsToFloat xs;
                                nrm = maxInList (map normValue xsf);
                                xsfn = map (normV nrm) xsf;
                                r = trainSequence xsf xsfn bias w1 w2 False;
                                w = fst r;
                                updated = snd r
                              } in
                              if (not(updated)) then (w, True)
                              else if (n<=0) then (w, not(updated))
                              else trainNeuron xs (fo3 w) (so3 w) (to3 w) (n-1)

--
-- LOCN 50 50 true
-- STYLE 
--
import M_Util
--
-- LOCN 875 75 true
-- STYLE 
--
trainSequence xs xsn bias w1 w2 updated = case xs of
                              {
                                y:[] -> trainStep (fo3 y) (so3 y) (to3 y) (fst (head xsn)) (snd (head xsn)) bias w1 w2 updated;
                                y:ys -> let {
                                             r = trainStep (fo3 y) (so3 y) (to3 y) (fst (head xsn)) (snd (head xsn)) bias w1 w2 updated;
                                             w = fst r
                                            }
                                        in trainSequence ys (tail xsn) (fo3 w) (so3 w) (to3 w) (snd r)
                              }

--
-- LOCN 50 275 true
-- STYLE 
--
trainStep u1 u2 t u1n u2n bias w1 w2 alreadyUpdated = if (t*(bias + (u1*w1) + (u2*w2)))>0.0 then ((bias,w1,w2), (alreadyUpdated || False))
                                                                  else (((bias+t), (w1+(t*u1n)), (w2+(t*u2n))), True)

--
-- LOCN 50 450 true
-- STYLE 
--
trainNeuron [((-1),0,(-1)), ((-1),1,1), (1,0,1), (1,1,(-1))] 1.0 1.0 1.0 27
--
-- LOCN 950 575 true
-- STYLE 
--
trainNeuron [((-1),0,1), ((-1),1,1), (1,0,(-1)), (1,1,(-1))] 1.0 1.0 1.0 27
--
-- LOCN 950 675 true
-- STYLE 
--
trainStep 2.0 2.0 (-1.0) 2.0 2.0 1.0 1.0 1.0 False
--
-- LOCN 950 750 true
-- STYLE 
--
trainNeuron [(0,0,(-1)),(40,100,(-1)),(110,20,1)] 1.0 (-2.0) 3.0 27
--
-- LOCN 950 825 true
-- STYLE 
--
normValue u = let
              {
                nrm = sqrt(((fo3 u)^2) + ((so3 u)^2))
              }
              in
              nrm

--
-- LOCN 50 575 true
-- STYLE 
--
normWeight w = let
               {
                 nrm = sqrt(((fo3 w)^2) + ((so3 w)^2) + ((to3 w)^2))
               }
               in
               ((fo3 w)/nrm, (so3 w)/nrm, (to3 w)/nrm)

--
-- LOCN 50 800 true
-- STYLE 
--
pointToFloat p = (fromInt(fo3 p), fromInt(so3 p), fromInt(to3 p))
--
-- LOCN 50 950 true
-- STYLE 
--
pointsToFloat xs = case xs of
                   {
                     [] -> [];
                     (y:ys) -> (pointToFloat y):(pointsToFloat ys)
                   }

--
-- LOCN 50 1025 true
-- STYLE 
--
pointsToFloat [(1,2,1),(3,2,0)]
--
-- LOCN 975 1050 true
-- STYLE 
--
normV nrm x = ((fo3 x)/nrm, (so3 x)/nrm)
--
-- LOCN 50 725 true
-- STYLE 
--
maxInList xs = case xs of
               {
                 [] -> 0.0;
                 (y:ys) -> maxFloat y (maxInList ys)
               }
--
-- LOCN 50 1150 true
-- STYLE 
--
maxFloat a b = if a<b then b else a
--
-- LOCN 50 1275 true
-- STYLE 
--
maxInList [0.0, 1.0, 2.0, 1.0]
--
-- LOCN 950 1150 true
-- STYLE 
{-
M_Util
-}
-- LOCN 775 75 true
-- STYLE open "M_Util"
--
import Styles
--
-- LOCN 875 25 true
-- STYLE 
{-
Zurck zum letzten Dokument
-}
-- LOCN 650 25 true
-- STYLE open ""
