-- Vital 2.1
--
divides a b = any (b==) (map (*a) [(min b (-b))..(max b (-b))])

--
-- LOCN 50 50 true
-- STYLE 
--
multiple b a = divides a b

--
-- LOCN 50 100 true
-- STYLE 
--
congruent a b m = m `divides` (a-b)

--
-- LOCN 50 150 true
-- STYLE 
--
expmod b a n = let {abin = bin a; k = length abin; bs = bPowers b k n}
                in cProduct 1 abin bs n

--
-- LOCN 50 200 true
-- STYLE 
--
expmult a b n = (a*b) `mod` n

--
-- LOCN 50 250 true
-- STYLE 
--
cProduct c abin bPow n = if (length abin)==0 then (c `mod` n)
                          else cProduct (expmult c ((head bPow)^(head abin)) n) (tail abin) (tail bPow) n

--
-- LOCN 50 300 true
-- STYLE 
--
bPowers b k n = case k of{
                 0 -> [];
                 otherwise -> (bPowers (expmult b b n) (k-1) n)++[b]
                }

--
-- LOCN 50 375 true
-- STYLE 
--
bin a = case a of{
          0 -> [0];
          otherwise -> let{amod = a `mod` 2; adiv = a `div` 2}
                       in if adiv==0 then [amod]
                          else (bin adiv)++[amod]
        }

--
-- LOCN 50 475 true
-- STYLE 
--
r i a b = case i of
          {
            0 -> a;
            1 -> b;
            otherwise -> (r (i-2) a b) `mod` (r (i-1 )a b)
          }

--
-- LOCN 50 600 true
-- STYLE 
--
rs a b = takeWhile (>0) [r i a b | i <- [0..] ]

--
-- LOCN 50 725 true
-- STYLE 
--
euclidGCD a b = last (takeWhile (>0) (rs a b))

--
-- LOCN 50 750 true
-- STYLE 
--
q i a b = (r (i-1) a b) `div` (r i a b)

--
-- LOCN 50 825 true
-- STYLE 
--
s i a b = case i of
          {
            0 -> 1;
            1 -> 0;
            otherwise -> (s (i-2) a b) - (q (i-1) a b)*(s (i-1) a b)
          }

--
-- LOCN 50 875 true
-- STYLE 
--
t i a b = case i of
          {
            0 -> 0;
            1 -> 1;
            otherwise -> (t (i-2) a b) - (q (i-1) a b)*(t (i-1) a b)
          }

--
-- LOCN 50 1000 true
-- STYLE 
--
sSequence a b = [s i a b | i <- [0..((length (rs a b))-1)] ]

--
-- LOCN 50 1125 true
-- STYLE 
--
tSequence a b = [t i a b | i <- [0..((length (rs a b))-1)] ]

--
-- LOCN 50 1175 true
-- STYLE 
--
extendedEuclid a b = a * last (sSequence a b) + b * last (tSequence a b)

--
-- LOCN 50 1225 true
-- STYLE 
--
prime n = not (any (multiple n) [2..(intSqrt n)])

--
-- LOCN 50 1325 true
-- STYLE 
--
intSqrt n = last [x | x <- [1..n], (x*x)<=n]

--
-- LOCN 50 1375 true
-- STYLE 
--
primes n = sieve2 [2..n]

--
-- LOCN 50 1425 true
-- STYLE 
--
sieve ys = case ys of
           {
             []   -> [];
             x:xs -> x:sieve [d | d <-xs, not (d `multiple` x)]
           }

--
-- LOCN 50 1475 true
-- STYLE 
--
fermatTest n b = congruent (expmod b (n-1) n) 1 n

--
-- LOCN 50 1575 true
-- STYLE 
--
millerTest n b = let
                 {
                  st = millerSandT n;
                  s = fst st;
                  t = snd st;
                  bs = [expmod b ((2^i)*t) n| i <- [0,1..(s-1)]]
                 }
                 in ((congruent (expmod b t n) 1 n) || (any (congruentMinus1 n) bs))

--
-- LOCN 50 1625 true
-- STYLE 
--
congruentMinus1 m a = congruent a (-1) m

--
-- LOCN 50 1775 true
-- STYLE 
--
millerSandT n = let {s = last (takeWhile (isLowerThanS n) [0..]); t = (n-1) `div` (2^s)}
                 in (s,t)

--
-- LOCN 50 1825 true
-- STYLE 
--
isLowerThanS n i = (n-1) `mod` (2^i)==0

--
-- LOCN 50 1875 true
-- STYLE 
--
extEuclid a b = [['i', 'r', 's', 't']] ++ [ [i, r i a b, s i a b, t i a b] | i <- [0..((length (takeUntilIncl (==0) [r y a b | y <- [0..] ] ))-1)]  ]
--
-- LOCN 50 1275 true
-- STYLE 
--
extEuclid 16 39
--
-- LOCN 725 600 true
-- STYLE table' box4 fmt1
--
import Styles
--
-- LOCN 1000 50 true
-- STYLE 
--
import M_Util
--
-- LOCN 1000 100 true
-- STYLE 
--
sieve2 ys = case ys of
           {
             []   -> [];
             x:xs -> x:sieve2 [d | d <-xs, not((d `mod` x)==0)]
           }

--
-- LOCN 625 1475 true
-- STYLE 
{-
M_Util
-}
-- LOCN 900 100 true
-- STYLE open "M_Util"
--
gcdTuple a b = ((a, b), euclidGCD a b)
--
-- LOCN 50 775 true
-- STYLE 
{-
Zurck zum letzten Dokument
-}
-- LOCN 675 25 true
-- STYLE open ""
