-- Vital 2.1
{-
Experiments with Maths layout (LaTeX like)
-}
-- LOCN 50 50 true
-- STYLE title
--
import SS
--
-- LOCN 725 75 true
-- STYLE 
--
fmt = Format Serif 30 red False True
--
-- LOCN 502 92 false
-- STYLE 
--
data BB = BEmpty {w :: Int, h :: Int}
        | BString {w :: Int, h :: Int, s :: String, f :: Format}
        | BSigma {w :: Int, h :: Int}
        | BList {w :: Int, h :: Int, boxes :: [BB]}
        | BTrans {w :: Int, h :: Int, x :: Int, y :: Int, box :: Box}
--
-- LOCN 57 228 true
-- STYLE 
--
mkEmpty w h = BEmpty w h
--
-- LOCN 56 457 true
-- STYLE Hide
--
mkText str fmt = let { n = length str;
                       sf = case fmt of Format _ ps _ _ _ -> div ps 2;
                       w = n * sf;
                       h = 2 * sf
                    } in BString w h str fmt
--
-- LOCN 60 505 true
-- STYLE Hide
--
showBox bb = case bb of {
              BEmpty w h         -> Trans 0 (- h) (Rect w h trans bc);
              BString w h s fmt  -> Super (PicText fmt s) (Trans 0 (- h) (Rect w h trans bc));
              BSigma w h         -> showSigma `Super` (Trans 0 (-h) (Rect w h trans bc));
              BList w h boxes    -> showBoxes boxes;
              BTrans w h x y box -> (Trans x (- y) (showBox box)) `Super` (Trans 0 (- h) (Rect w h trans bc))
            }
--
-- LOCN 65 721 true
-- STYLE Hide
--
b1 = mkEmpty 40 20
--
-- LOCN 702 301 false
-- STYLE 
--
b2 = mkText "Hello" fmt
--
-- LOCN 702 318 true
-- STYLE Hide
--
showBox b1
--
-- LOCN 701 483 true
-- STYLE Picture
--
showBox b2
--
-- LOCN 700 544 true
-- STYLE Picture
--
showBoxes boxes = case boxes of {
                  [] -> NoPic;
                  box : boxes -> let w = getWidth box
                                 in (showBox box) `Super` (Trans w 0 (showBoxes boxes))
                }
--
-- LOCN 69 864 true
-- STYLE Hide
--
getSize bb = case bb of {
                BEmpty w h       -> (w, h);
                BString w h _ _  -> (w, h);
                BSigma w h       -> (w, h);
                BList w h _      -> (w, h);
                BTrans w h _ _ _ -> (w, h)
           }
--
-- LOCN 56 345 true
-- STYLE Hide
--
mkList boxes = let {sizes = map getSize boxes;
                    w = sum (map fst sizes);
                    h = maximum (map snd sizes)
               } in BList w h boxes
--
-- LOCN 60 584 true
-- STYLE Hide
--
getWidth = fst . getSize
--
-- LOCN 452 347 true
-- STYLE Hide
--
getHeight = snd . getSize
--
-- LOCN 451 367 true
-- STYLE Hide
--
b3 = mkList [b1, b2, b1]
--
-- LOCN 702 339 false
-- STYLE 
--
showBox b3
--
-- LOCN 701 625 true
-- STYLE Picture
--
mkTrans x y box = let { w = getWidth box;
                       h = getHeight box
                 } in BTrans (w + x) (h + y) x y box
--
-- LOCN 62 652 true
-- STYLE Hide
--
b4 = mkTrans 0 25 b1
--
-- LOCN 701 367 false
-- STYLE 
--
showBox b4
--
-- LOCN 703 705 true
-- STYLE Picture
--
b10 = mkText "5x" fmt
--
-- LOCN 66 964 false
-- STYLE 
--
b11 = mkText "2n" fmt'
--
-- LOCN 65 982 false
-- STYLE 
--
fmt' = Format Serif 20 red False True
--
-- LOCN 502 110 false
-- STYLE 
--
b12 = mkTrans 0 10 b11
--
-- LOCN 65 998 false
-- STYLE 
--
showBox b12
--
-- LOCN 611 962 true
-- STYLE Picture
--
showBox b11
--
-- LOCN 489 963 true
-- STYLE Picture
--
showBox b10
--
-- LOCN 361 963 true
-- STYLE Picture
--
b13 = mkList [b10, b12]
--
-- LOCN 64 1025 false
-- STYLE 
--
showBox b13
--
-- LOCN 364 1028 true
-- STYLE Picture
--
space = mkEmpty 5 0
--
-- LOCN 72 1119 false
-- STYLE 
--
bc = green
--
-- LOCN 504 196 false
-- STYLE 
--
mkMain s = mkText s fmt
--
-- LOCN 71 1134 true
-- STYLE Hide
--
mkSuper s = mkTrans 0 10 (mkText s fmt')
--
-- LOCN 71 1150 true
-- STYLE Hide
--
b17 = mkList [mkSigma,
              mkMain "12x", mkSuper "3", 
              mkOper "+", 
              mkMain "2x", mkSuper "2",
              mkOper "-",
              mkMain "9x",
              mkOper "+",
              mkMain "14"
            ]
--
-- LOCN 68 1437 false
-- STYLE 
--
mkOper s = let op = mkText s fmt
           in mkList [space, op, space]
--
-- LOCN 70 1171 true
-- STYLE Hide
--
egPic = showBox b17
--
-- LOCN 460 1432 true
-- STYLE Picture
--
a1 = 10
--
-- LOCN 523 1224 false
-- STYLE 
--
a2 = 8
--
-- LOCN 524 1236 false
-- STYLE 
--
a3 = 12
--
-- LOCN 525 1250 false
-- STYLE 
--
a4 = a1 + a2
--
-- LOCN 663 1221 false
-- STYLE 
--
a5 = a3 + a3
--
-- LOCN 662 1237 false
-- STYLE 
--
sig1 = Line a4 0 red
--
-- LOCN 568 1269 false
-- STYLE Picture
--
sig2 = Line a1 (-a3) red
--
-- LOCN 569 1280 false
-- STYLE Picture
--
sig3 = Trans a1 (-a3) (Line (-a1) (-a3) red)
--
-- LOCN 570 1292 false
-- STYLE Picture
--
sig4 = Trans 0 (-a5) sig1
--
-- LOCN 570 1306 false
-- STYLE Picture
--
showSigma = foldl1 Super [sig1, sig2, sig3, sig4]
--
-- LOCN 568 1321 true
-- STYLE Hide
--
mkSigma = mkList [BSigma a4 a5, space]
--
-- LOCN 77 1214 true
-- STYLE Hide
--
showBox (mkSigma)
--
-- LOCN 494 1024 true
-- STYLE Picture
{-
Box colour  (set to (eg) green to show boxes explicitly,
or to "trans" to make them invisible)
-}
-- LOCN 500 150 true
-- STYLE comment
{-
Main a space, "main" text, "superscript text", an operator, or a sigma
-}
-- LOCN 75 1100 true
-- STYLE 
{-
Define how to draw a Sigma
-}
-- LOCN 521 1194 true
-- STYLE 
{-
Example
-}
-- LOCN 69 1398 true
-- STYLE 
--
egPic


--
-- LOCN 50 100 true
-- STYLE Picture
{-
Experiments with TeX-like layout of maths formulae.
-}
-- LOCN 50 -50 true
-- STYLE abstract
