-- Vital 2.1
--
import SS
--
-- LOCN 675 50 true
-- STYLE 
{-
Direct manipulation of Midi scores
-}
-- LOCN 50 75 true
-- STYLE title
--
import Midi
--
-- LOCN 675 75 true
-- STYLE 
--
import MidiLib
--
-- LOCN 675 100 true
-- STYLE 
--
import ActionLib
--
-- LOCN 675 125 true
-- STYLE 
{-
Back to previous document
-}
-- LOCN 675 175 true
-- STYLE open1 ""
{-
Demo of the MidiLib functions for diplaying, playing and editing a score.
-}
-- LOCN 50 -50 true
-- STYLE abstract
{-
The types and functions defined in the MidiLib library module
allow Midi sequences to be displayed and edited using a simplified
musical notation.
-}
-- LOCN 75 150 true
-- STYLE comment
--
score1 :: Score
--
-- LOCN 75 325 true
-- STYLE 
--
score1 = Score [Note 20 10 Minim Forte, Note 20 12 Minim Forte, Note 20 14 Minim Forte, Note 20 7 Minim Forte, Note 19 6 Demisemiquaver Forte, Note 18 7 Demisemiquaver Forte, Note 17 9 Demisemiquaver Forte, Note 16 8 Demisemiquaver Forte, Note 15 6 Demisemiquaver Forte, Note 14 7 Crotchet Forte, Note 12 8 Crotchet Forte, Note 10 9 Crotchet Forte, Note 8 10 Crotchet Forte, Note 6 11 Crotchet Forte, Note 4 12 Crotchet Forte, Note 2 13 Crotchet Forte, Note 0 14 Crotchet Forte]
--
-- LOCN 75 350 true
-- STYLE 
--
button "Play" $ play instrument score1
--
-- LOCN 75 575 true
-- STYLE 
{-
For example, here is a simple score:
-}
-- LOCN 75 275 true
-- STYLE comment
{-
This score can be played by double-clicking this button:
-}
-- LOCN 75 550 true
-- STYLE comment
--
instrument = 10
--
-- LOCN 650 550 true
-- STYLE hide
{-
Direct manipulation
-}
-- LOCN 50 700 true
-- STYLE heading1
{-
Here is a blank score (in the treble clef, in the key of C major)
-}
-- LOCN 75 750 true
-- STYLE comment
--
score2 = Score []
--
-- LOCN 75 800 true
-- STYLE 
{-
You can fill in notes in this score by:
  -  double-clicking the score to select it (as indicated by its selection boundary appearing);
  -  right-clicking within the score to place or to delete a note, or to simplify (ie, evaluate) the expression
You can play the resultant score by double-clicking this button:
-}
-- LOCN 75 975 true
-- STYLE comment
--
button "Play" (play instrument score2)
--
-- LOCN 75 1075 true
-- STYLE 
{-
Saving the Midi sequence to file
-}
-- LOCN 50 1225 true
-- STYLE heading1
{-
By changing the value of "instrument", you
change the instrument on which the score is
played. Interesting choices are:
   0   piano
   10  music box
   13  xylophone
   19  church organ
   25  steel string guitar
   47  timpani
   56  trumpet
   123 bird
-}
-- LOCN 650 575 true
-- STYLE comment
{-
Pressing the following button will save your composition as a Midi
file in the vital/midi/  subdirectory.
-}
-- LOCN 75 1275 true
-- STYLE comment
--
button "Save" (save "tune.mid" instrument score2)
--
-- LOCN 75 1325 true
-- STYLE 
{-
Note: The default security policy of programs run
under WebStart does not allow write-access to the
filesystem. Thus, this operation will only work
if the system is being run as a Java "application".
-}
-- LOCN 625 1275 true
-- STYLE alert2
{-
Back to previous document
-}
-- LOCN 50 1475 true
-- STYLE open1 ""
