-- Vital 2.1
--
import SS
--
-- LOCN 650 50 true
-- STYLE 
--
import Midi
--
-- LOCN 650 75 true
-- STYLE 
{-
Scales
-}
-- LOCN 50 75 true
-- STYLE title
--
duration =4
--
-- LOCN 50 175 true
-- STYLE hide
--
instrument = 0
--
-- LOCN 50 200 true
-- STYLE hide
--
midiInstrumentName instrument
--
-- LOCN 400 175 true
-- STYLE 
--
vel = 90
--
-- LOCN 50 225 true
-- STYLE hide
--
playTune pitches = 
  let {events = makeEvents 0 pitches;
       seq = Sequence [Track instrument events];
       midiSeq = mkMidiSequence seq;
       action = playMidi midiSeq
  } in PicAction 80 20 cyan blue action
--
-- LOCN 50 625 true
-- STYLE 
--
stop = PicAction 80 20 yellow blue stopMidi
--
-- LOCN 425 900 true
-- STYLE 
--
eqTmpScale =  0: 2: 4: 5: 7: 9: 11: map (+ 12) eqTmpScale
--
-- LOCN 50 775 true
-- STYLE 
--
playTune :: [Pitch] -> Action
--
-- LOCN 50 600 true
-- STYLE 
--
makeEvents :: Time -> [Pitch] -> [MidiEvent]
--
-- LOCN 50 300 true
-- STYLE 
--
makeEvents tick pitches =
  case pitches of {
    []     -> [];
    pitch : pitches -> 
      let tick' = tick + duration
      in NoteOn pitch vel tick : NoteOff pitch vel tick' : makeEvents tick' pitches
    }
--
-- LOCN 50 325 true
-- STYLE 
--
playTune (scale ++ reverse scale)
--
-- LOCN 50 900 true
-- STYLE 
--
scale = take 8 (drop 21 eqTmpScale)
--
-- LOCN 50 850 true
-- STYLE hide
--
makeEvents 0 [10, 20, 30]
--
-- LOCN 50 500 true
-- STYLE 
{-
NB: Only 7 distinct notes in a scale!
-}
-- LOCN 375 850 true
-- STYLE comment
{-
For example:
-}
-- LOCN 50 475 true
-- STYLE comment
{-
Plays a scale of C major.
-}
-- LOCN 50 -25 true
-- STYLE abstract
