-- Vital 2.1
--
num // denom = 
  let { q  = div num denom;
        r  = mod num denom }
  in q : ((base * r) // denom)
--
-- LOCN 50 1125 true
-- STYLE Hide
--
twoSevenths = 2 // 7
--
-- LOCN 50 1525 true
-- STYLE cr
--
base = 16
--
-- LOCN 50 975 false
-- STYLE 
--
fiveSevenths = 5 // 7
--
-- LOCN 50 1600 true
-- STYLE cr
--
half = 2 // 4
--
-- LOCN 50 1450 true
-- STYLE cr
--
twoThirds = 2 // 3
--
-- LOCN 50 1675 true
-- STYLE cr
--
us <+> vs = normalise (add us vs)
--
-- LOCN 50 2700 true
-- STYLE Hide
--
add = zipWith (+)
--
-- LOCN 50 1950 true
-- STYLE Hide
--
normalise us =
  let { u0 = head us;  us'  = tail us; 
        u1 = head us'; us'' = tail us';
        vs = normalise us';
        v0 = head vs;  vs'  = tail vs} in
  case u1 `compare` maxDigit of {
    LT -> u0 : vs;
    GT -> (u0 + 1) : normalise ((u1 - base) : us'');
    EQ -> if v0 < base then u0 : vs
          else (u0 + 1) : ((v0 - base) : vs')}
--
-- LOCN 50 2450 true
-- STYLE Hide
--
maxDigit = base - 1
--
-- LOCN 250 975 false
-- STYLE 
--
neg us = (negate (head us) - 1) : map (maxDigit -) (tail us)
--
-- LOCN 50 3225 true
-- STYLE Hide
--
neg three
--
-- LOCN 50 3325 true
-- STYLE cr
--
us >/ m =
  let dvd = \c ws -> let {w0 = head ws; ws' = tail ws;
                          k = (base * c) + w0;
                          n = div k m;  r = mod k m}
                       in n : dvd r ws'
  in dvd 0 us
--
-- LOCN 50 3575 true
-- STYLE Hide
--
three >/ 2
--
-- LOCN 50 3750 true
-- STYLE cr
{-
Negation of a numeral can be effected by complementing the digits of the fractional part and subtracting 1.
-}
-- LOCN 50 3150 true
-- STYLE comment
--
m *> us = 
  case m of {
    0 -> zero;
    1 -> us;
    m -> let {u0 = head us; us' = tail us;
              u1 = head us'; us'' = tail us';
              k = m * ((u0 * base) + u1);
              c = div k base;
              r = mod k base;
              cm = \c r vs ->
                       let {v0 = head vs; vs' = tail vs;
                            k1 = m * v0;
                            a = div k1 base;  b = mod k1 base;
                            p = a + r;
                            ws = cm p b vs';
                            w0 = head ws; ws' = tail ws}
                       in case p `compare` maxDigit of {
                            LT -> c : cm p b vs';
                            GT -> (c + 1) : cm (p - base) b vs';
                            EQ -> if w0 < base then c : ws
                                  else (c + 1) : (0 : ws')} }
         in cm c r us''}
--
-- LOCN 50 4000 true
-- STYLE Hide
--
2 *> twoThirds
--
-- LOCN 50 4425 true
-- STYLE cr
--
bconv us nBase = (head us) : bconv (nBase *> (0 : tail us)) nBase
--
-- LOCN 50 4825 true
-- STYLE Hide
--
frm i = let { j = 8 * i;
              r = (4 % (j + 1)) +% ((-2) % (j + 4)) +% ((-1) % (j + 5)) +% ((-1) % (j + 6))}
        in  numerator r // denominator r
              
--
-- LOCN 50 5675 true
-- STYLE Hide
{-
. . . and the result of applying this function to the above (infinite) list of computable
reals is a representation (in base 16) of the value of pi: 
-}
-- LOCN 50 6475 true
-- STYLE comment
--
ssum wss =
  let {us = head wss; wss' = tail wss;
       u0 = head us; us' = tail us;
       u1 = head us'; us'' = tail us';
       vs = head wss'; wss'' = tail wss';
       v0 = head vs} 
  in if (u1 + v0) < maxDigit
     then u0 : ssum (((u1 : us'') <+> vs) : wss'')
     else let xs = ssum (vs : wss'')
          in us <+> (0 : xs)
       
--
-- LOCN 50 6300 true
-- STYLE Hide
--
ssum :: [ CR ] -> CR
--
-- LOCN 50 6275 true
-- STYLE 
--
piDecimal = bconv piHex 10
--
-- LOCN 50 6700 true
-- STYLE cr
--
piHex = ssum fractions
--
-- LOCN 50 6525 true
-- STYLE cr
{-
All that then remains to produce the decimal representation of pi is to use the base conversion function 
defined earlier to convert this numeral to base 10:
-}
-- LOCN 50 6625 true
-- STYLE comment
--
fractions = map frm [0 ..]
--
-- LOCN 50 5800 true
-- STYLE Hide
--
import SS
--
-- LOCN 775 75 true
-- STYLE 
--
take 6 fractions
--
-- LOCN 50 5900 true
-- STYLE table box2 fmt3
{-
This document is based on the paper by Jerzy Karczmarczuk:

                           "The Most Unreliable Technique in the World to compute pi"

Abstract:  This paper is an atypical exercise in lazy functional coding, written for fun and instruction. It can
be read and understood by anybody who understands the programming language Haskell. We show how to implement the
Bailey-Borwein-Plouffe formula for pi in a co-recursive incremental way which produces the digits 3, 1, 4, 1, 5, 9 ...
until the memory exhaustion. This is _not_ a way to proceed if somebody needs many digits! Our coding strategy is
perverse and dangerous, and it _provably_ breaks down. It is based on the arithmetics over the domain of infinite
sequences of digits representing proper fractions expanded in an integer base. We show how to manipulate: add,
multiply by an integer, etc. such sequences from the left to the right ad infinitum, which obviously cannot work
in all cases because of ambiguities. Some deep philosophical consequences are discussed in the conclusions.

(1998, unpublished, but available via  http://www.info.unicaen.fr/~karczma/arpap/lazypi.ps.gz)
-}
-- LOCN 50 200 true
-- STYLE comment
{-
Infinite decimal expansion of pi derived 
using the BBP expansion
-}
-- LOCN 50 75 true
-- STYLE title
{-
Representation of the computable reals
-}
-- LOCN 50 600 true
-- STYLE heading1
{-
In this approach, the computatable reals are represented, using the ordinary positional
notation, as lazy lists and the elementary arithmetic functions (addition, subtraction, etc.)
as functions over these lists
-}
-- LOCN 50 650 true
-- STYLE comment
{-
We tackle the problem in two parts: first, we define an implementation of the computable reals and then
we use this implementation to sum the terms of the BBP expansion for pi.
-}
-- LOCN 50 500 true
-- STYLE comment
{-
The radix of the representation can be any integer greater than one. For the following examples we choose
to use base 16 (but do explore the effect of changing this to other values, such as 2 or 10 or 293 or whatever . . .).

>>   But, please note, the value must be 16 for the second part of this document (ie, the part concerned
>>   with computing the value of pi).
-}
-- LOCN 50 850 true
-- STYLE comment
{-
We define a function to convert from a rational (expressed as num/denom) to a real.  (We assume the head of
the list represents the integer value (as a single number, not an expansion) and the tail of the list
represents the fractional part.) 
-}
-- LOCN 50 1025 true
-- STYLE comment
--
type CR = [Int]
--
-- LOCN 50 725 true
-- STYLE 
--
(//) :: Int -> Int -> CR
--
-- LOCN 50 1100 true
-- STYLE 
--
zero, three, half, twoSevenths, fiveSevenths, twoThirds :: CR
--
-- LOCN 50 1250 true
-- STYLE 
--
zero = 0 // 1
--
-- LOCN 50 1300 true
-- STYLE cr
{-
Here are some examples:
-}
-- LOCN 50 1225 true
-- STYLE comment
{-
(Do try going back and altering the value of "base" -- for example to 7 -- to see the effect. You can
 then click the "Undo" button to undo the change.)
-}
-- LOCN 50 1800 true
-- STYLE comment
--
three = 3 // 1
--
-- LOCN 50 1350 true
-- STYLE cr
{-
Now define the operation of addition on these numerals. We do this in two stages: first
the pairwise addition of corresponding digits (which, of course may yield an unnormalised numeral)
-}
-- LOCN 50 1875 true
-- STYLE comment
--
add :: CR -> CR -> CR
--
-- LOCN 50 1925 true
-- STYLE 
{-
Try this out on some examples:
-}
-- LOCN 50 2025 true
-- STYLE comment
--
half `add` twoThirds
--
-- LOCN 50 2050 true
-- STYLE cr
--
cr = list2
--
-- LOCN 675 750 true
-- STYLE Hide
--
crs = table2
--
-- LOCN 675 775 true
-- STYLE Hide
{-
Define styles for the computable reals
-}
-- LOCN 675 725 true
-- STYLE comment
--
twoSevenths `add` fiveSevenths
--
-- LOCN 50 2200 true
-- STYLE cr
{-
Now define a function to normalise numerals (ie, to ensure that all digits are strictly less than the radix). This
function, which propagates carries from right to left, but has to evaluate from left to right, may have to look 
ahead an _arbitrary_ amount (and therein lies a problem . . .)
-}
-- LOCN 50 2350 true
-- STYLE comment
--
twoThirds `add` fiveSevenths
--
-- LOCN 50 2125 true
-- STYLE cr
--
normalise :: CR -> CR
--
-- LOCN 50 2425 true
-- STYLE 
{-
We can now define a normalised version of addition
-}
-- LOCN 50 2650 true
-- STYLE comment
--
(<+>) :: CR -> CR -> CR
--
-- LOCN 50 2675 true
-- STYLE 
{-
The first two of the abov examples now yield normalised digits:
-}
-- LOCN 50 2750 true
-- STYLE comment
--
half <+> twoThirds
--
-- LOCN 50 2775 true
-- STYLE cr
--
twoThirds <+> fiveSevenths
--
-- LOCN 50 2850 true
-- STYLE cr
{-
. . . but note that attempting to evaluate the third of the above examples, namely:
             twoSevenths <+> fiveSevenths
would result in an unbounded recursion since every digit has the value  (base-1)  and therefore propagates
a carry (unless, as a special case, the base happens to be a multiple of 7).

(This awkward behaviour is a manifestation of the discontinuous nature of representation in (non-redundant)
radix notations. For example, both decimal numerals  1.999...  and  2.000... represent the same value,
but they would have to be evaluated to infinite depth to demonstrate equality. . .
-}
-- LOCN 50 2950 true
-- STYLE comment
{-
Notice that the above numeral consists of an infinite sequence of digits with the value (base-1).
-}
-- LOCN 50 2300 true
-- STYLE comment
--
neg :: CR -> CR
--
-- LOCN 50 3200 true
-- STYLE 
{-
For example . . .
-}
-- LOCN 50 3275 true
-- STYLE comment
--
neg twoSevenths
--
-- LOCN 50 3400 true
-- STYLE cr
{-
Division of a computable real by an integer is easy (since any 'borrows' propagate in the same direction as evaluation):
-}
-- LOCN 50 3500 true
-- STYLE comment
--
(>/) :: CR -> Int -> CR
--
-- LOCN 50 3550 true
-- STYLE 
{-
For example:
-}
-- LOCN 50 3700 true
-- STYLE comment
--
fiveSevenths >/ 13
--
-- LOCN 51 3808 true
-- STYLE cr
{-
Other the other hand, multiplication of a computable real by an integer is, as Karczmarczuk remarks, a /horrendum/.
-}
-- LOCN 50 3925 true
-- STYLE comment
--
(*>) :: Int -> CR -> CR
--
-- LOCN 50 3975 true
-- STYLE 
{-
For example:
-}
-- LOCN 50 4375 true
-- STYLE comment
{-
As usual, there will be some computations that do not terminate. For example, an attempt to evaluate
     3 *> twoThirds
would fail (unless the base happens to be a multiple of 3).
-}
-- LOCN 50 4625 true
-- STYLE comment
--
19 *> (fiveSevenths >/ 13)
--
-- LOCN 50 4500 true
-- STYLE cr
{-
The final operation we will need is radix conversion. Given multiplication, this operation is easy: it simply 
involves repeated multiplication by the new base (nBase) and selection of the integer part.
-}
-- LOCN 50 4725 true
-- STYLE comment
--
bconv :: CR -> Int -> CR
--
-- LOCN 50 4800 true
-- STYLE 
{-
For example, to convert the computable real (presently expressed in radix "base", as declared near the start of
the document) that represents 5/7  to the corresponding numeral expressed in radix 10:
-}
-- LOCN 50 4900 true
-- STYLE comment
--
bconv fiveSevenths 10
--
-- LOCN 50 4950 true
-- STYLE cr
{-
or expressed in radix 2:
-}
-- LOCN 50 5050 true
-- STYLE comment
--
bconv fiveSevenths 2
--
-- LOCN 50 5075 true
-- STYLE cr
{-
Computation of the decimal expansion of pi
-}
-- LOCN 50 5300 true
-- STYLE heading1
{-
This completes the definition of the operations on the computable reals that we need for the second part.
-}
-- LOCN 50 5175 true
-- STYLE comment
{-
This method for expressing pi as a computable real relies upon the following expansion for pi
recently (1997) discoved by Bailey, Borwein and Plouffe:

pi = Summation over i = 0, 1, 2, ... of     ( 4/(8i+1) - 2/(8i+4) - 1/(8i+5) - 1/(8i+6)) / 16^i
-}
-- LOCN 50 5350 true
-- STYLE comment
{-
We first import the Ratio library (that defines the type "Rat" of rational numbers, the infix operator "%" for 
constructing these numbers, the infix operator "+%" for adding them and the projector funtions, "numerator" 
and "denominator").
-}
-- LOCN 50 5475 true
-- STYLE comment
--
import Ratio
--
-- LOCN 50 5550 true
-- STYLE 
{-
We define a function, frm, that sums the four fractions (without the 1/16^i scale factor) that make up a term 
of the BBP series and expresses it as a computable real
-}
-- LOCN 50 5600 true
-- STYLE comment
--
frm :: Int -> CR
--
-- LOCN 50 5650 true
-- STYLE 
{-
We can then define the (infinite) list of all these computable reals
-}
-- LOCN 50 5750 true
-- STYLE comment
{-
For example, the first 6 computable reals of this list are
-}
-- LOCN 50 5850 true
-- STYLE comment
{-
We now (see the above definition of the BBP series) wish to scale the successive elements of this list 
by powers of 1/16 and sum the resultant series. The operation of scaling by 1/16 can be realised by
a simple right shift by one digit position _provided_ we are working in base 16  (the value of "base", as
declared near the start of this document).
-}
-- LOCN 50 6075 true
-- STYLE comment
{-
Please change the declaration for "base" back to 16 !
-}
-- LOCN 50 6175 true
-- STYLE if (base == 16) then comment else warning1
{-
The following function performs this shift and sum operation
-}
-- LOCN 50 6225 true
-- STYLE comment
{-
It is fitting to leave the last word on this example to Jerzy Karczmarczuk:
  "Our main conclusion is that the program works, although it needn't to, and after a finite number of
   steps it will fail. In fact, this is the only such program which works without knowing how many digits
   it should generate, if at all. In such a way we prove that we have done serious work. A mathematically
   oriented reader whose private definition of the word "serious" is different from ours, may reject our
   technique, and our only defense is that this technique [of propagating carries from the, as yet,
   unevaluated tail of a list of digits] is not ours. . .  All the financial aid demanded by the governments
   of the Third World is based on the principle of borrowing money without any guarantee to pay it back one
   day. In practice this works, because the bank buffers of the rich countries are voluminous enough. The
   very idea of a bank credit is a lazy co-recursive (runaway) algorithm, and the true Game consists in
   running away before the bottom reaches you. The social security depenses in several european countries
   operate on non-existing funds which will (hopefully) un-virtualize themselves thanks to the work of
   future generations. Yes, the economy is non-strict science. So, why should we hesitate to borrow a
   carry from the "future" digits? At least this is our free choice, while paying taxes is not."
-}
-- LOCN 50 6800 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 775 100 true
-- STYLE open1 ""
{-
Back to previous document
-}
-- LOCN 50 7125 true
-- STYLE open1 ""
{-
A detailed exposition of how the computable reals may be represented by lists and how
arithmetic operations (+, -, *, /) may be implemented using this representation. 
Illustrated using the Bailey-Borwein-Plouffe expansion (1997) that expreses pi as an
infinite hexadecimal numeral and then converting this to decimal form.

Based on the paper "The most unreliable technique in the world to compute pi" by 
Jerzy Karczmarczuk (1998).
-}
-- LOCN 50 -150 true
-- STYLE abstract
