-- Vital 2.1
{-
Decimal expansion of pi
-}
-- LOCN 50 50 true
-- STYLE title
{-
*   Archimedes (c. 200 BCE) showed that
        223/71 < pi < 22/7

*   al-Khwarizmi (c. 800 CE) showed that
        pi = 3.1416

*   Gregory (c. 1650) showed that
        pi/4 = 1 - (1/3) + (1/5) - (1/7) + . . .

*   Shanks (c. 1760) proved that pi is irrational

*   Lindermann (c. 1870) proved that pi is transcendental
-}
-- LOCN 50 100 true
-- STYLE comment
--
f q r t k =
    let n = (3*q+r) `div` t in
    if (4*q+r) `div` t == n   then
       n : f (10*q) (10*(r-(n*t))) t k
    else
       f (q*k) ((q*(4*k+2)) + (r*(2*k+1))) (t*(2*k+1)) (k+1)
--
-- LOCN 475 250 true
-- STYLE Hide
--
f 1 0 1 1
--
-- LOCN 50 450 true
-- STYLE list2
--
import SS
--
-- LOCN 700 25 true
-- STYLE 
{-
More about this algorithm
-}
-- LOCN 700 375 true
-- STYLE open "PiSpigot"
{-
. . . and here is the resultant decimal expansion of pi (drag the document sideways
to see more of it or press the 'PV' (Perspective View) button and use the mouse wheel
to scroll along the sequence):
-}
-- LOCN 50 375 true
-- STYLE comment
{-
*   In 1997, Bailey, Borwein & Plouffe derived a power series
    expansion of pi that allows its n-th hexedecimal digit to
    be computed independently of the preceeding digits

*   In 2003, Jeremy Gibbons derived the following simple recurrence   
    relation that generates the infinite decimal expansion of pi:   
-}
-- LOCN 475 100 true
-- STYLE comment
{-
Decimal expansion of pi
-}
-- LOCN 50 525 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 700 50 true
-- STYLE open ""
{-
Back to previous document
-}
-- LOCN 50 575 true
-- STYLE open1 ""
{-
Brief historical summary of the notion of 'pi', and a recurrence relation
that generates the infinite decimal expansion of pi.
-}
-- LOCN 50 -50 true
-- STYLE abstract
