-- Vital 2.1
{-
Exercises 2-4.  Scaling and rotating pictures
-}
-- LOCN 50 100 true
-- STYLE title
--
import SS
--
-- LOCN 750 50 true
-- STYLE 
--
import Pictures
--
-- LOCN 750 75 true
-- STYLE 
--
import PictureWork2
--
-- LOCN 750 100 true
-- STYLE 
{-
Scalings and rotations obey many simple laws. Knowledge of these laws is useful
in many practical cases. For example, it often allows automatic optimisation of program.
-}
-- LOCN 50 175 true
-- STYLE comment
{-
Which of the following assertions are true (for arbitrary scale factors s1, s2 and s3, and
for arbitrary angles of rotation a1, a2 and a3) ? 

[i]
      scale s1 . scale s2   =   scale s2 . scale s1

[ii]
      scale s1 . (scale s2 . scale s3)  =  (scale s1 . scale s2) . scale s3

[iii]
      turn a1 . turn a2   =   turn a2 . turn a1

[iv]
      turn a1 . (turn a2 . turn a3)  =  (turn a1 . turn a2) . turn a3

[v]
      turn a1 . scale s1  =  scale s1 . turn a1

[vi]
      scale s1 . scale s2  =  scale (s1 * s2)

[vii]
      turn a1 . turn a2  =  turn (a1 + a2)
-}
-- LOCN 50 250 true
-- STYLE comment
{-
Take a couple of these assertions, choose arbitrary values for the scale factors and
for the angles (remember that the scale factor have to be of type Double and the angles
of type Int) and apply their left and their right hand sides to the "tile" picture.
Was your intuition correct?
-}
-- LOCN 50 750 true
-- STYLE comment
{-
For example:
-}
-- LOCN 725 750 true
-- STYLE comment
--
(turn a1 . turn a2) tile
--
-- LOCN 725 850 true
-- STYLE Picture
--
a1 = -97
--
-- LOCN 725 800 true
-- STYLE Hide
--
a2 = 37
--
-- LOCN 875 800 true
-- STYLE Hide
--
(turn a2 . turn a1) tile
--
-- LOCN 725 950 true
-- STYLE Picture
{-
Use your knowledge of the above laws to write down a function 
      f' :: Pic -> Pic

that is simpler than f but (in all cases) transforms a picture in an identical
way to f.
-}
-- LOCN 50 1025 true
-- STYLE comment
--
f = turn b1 . invertColor . scale s1 . scale s2 . invertColor . turn b2 . scale s3 . invertColor
--
-- LOCN 100 1325 true
-- STYLE Hide
--
b1 = 18
--
-- LOCN 100 1225 true
-- STYLE Hide
--
b2 = -39
--
-- LOCN 250 1225 true
-- STYLE Hide
--
s1 = 0.75
--
-- LOCN 400 1225 true
-- STYLE Hide
--
s2 = 6.0
--
-- LOCN 575 1225 true
-- STYLE Hide
--
s3 = 0.5
--
-- LOCN 725 1225 true
-- STYLE Hide
--
f :: Pic -> Pic
--
-- LOCN 100 1300 true
-- STYLE 
{-
Test your reasoning by applying both f and f' to the "tile" picture
-}
-- LOCN 50 1575 true
-- STYLE comment
{-
Your "efficient" definition for f' here, to replace the following dummy definition of f'
-}
-- LOCN 100 1400 true
-- STYLE 
{-
Your tests here
-}
-- LOCN 100 925 true
-- STYLE 
--
f tile
--
-- LOCN 175 1650 true
-- STYLE Picture
--
f' = f
--
-- LOCN 100 1475 true
-- STYLE Hide
--
f' tile
--
-- LOCN 500 1650 true
-- STYLE Picture
{-
Some laws involving translation, scaling and rotation
-}
-- LOCN 50 1875 true
-- STYLE heading1
{-
Which of the following assertions are true  (for arbitrary pictures p1 and p2, scale 
factors s1 and s2,  and rotations a1 and a2)?

[i]
       scale f1 (p1 <|> p2)  =  (scale f1 p1) <|> (scale f1 p2)

[ii]
      turn a1 (p1 <|> p2)  =  (turn a1 p1) <|> (turn a1 p2) 

[iii]
      flipV . flipH  =  flipH . flipV

[iv]
      turn a1 . flipV  =  flipV  . turn a1

[v]
      scale s1 . flipV  =  flipV . scale s1

[vi]
      flipV (p1 <|> p2)  =  (flipV p1) <|> (flipV p2)

[vii]
      flipH (p1 <|> p2)  =  (flipH p1) <|> (flipH p2)

[viii]
      flipV . flipH  =  turn (-90)
-}
-- LOCN 50 1950 true
-- STYLE comment
{-
More than one of the above assertions are wrong. Decide which ones these
are and, for each one, think up a pictorial counter-example that demonstrates
its incorrectness.
-}
-- LOCN 50 2500 true
-- STYLE comment
{-
For instance, the following example demonstrates
that the last of these assertions is definitely wrong!
-}
-- LOCN 625 2500 true
-- STYLE comment
--
(flipV . flipH) tile
--
-- LOCN 625 2575 true
-- STYLE Picture
--
turn (-90) tile
--
-- LOCN 850 2575 true
-- STYLE Picture
{-
Your pictorial counter-examples
-}
-- LOCN 75 2625 true
-- STYLE 
{-
Finally, here is an example to think about. Can you explain how this function
produces the effect it does?
-}
-- LOCN 50 2825 true
-- STYLE comment
{-
Challenge example
-}
-- LOCN 50 2775 true
-- STYLE heading1
--
stagger :: Int -> Pic -> Pic
--
-- LOCN 50 2900 true
-- STYLE 
--
stagger a = turn (-a) . beside . repeat . turn a
--
-- LOCN 50 2925 true
-- STYLE Hide
--
stagger 15 tile
--
-- LOCN 50 2975 true
-- STYLE Picture
{-
Your explanation
-}
-- LOCN 100 3200 true
-- STYLE 
{-
Back to previous document
-}
-- LOCN 50 3325 true
-- STYLE open1 ""
{-
Back to previous document
-}
-- LOCN 750 150 true
-- STYLE open1 ""
