-- Vital 2.1
--
import SS
--
-- LOCN 750 25 true
-- STYLE 
{-
Displaying lists pictorially
-}
-- LOCN 50 75 true
-- STYLE title
{-
An experiment to see how efficient (spacewise, timewise) it is to render lists pictorially rather than
to use the specialised "List" style.
-}
-- LOCN 50 150 true
-- STYLE abstract
--
listToPic :: [a] -> Pic
--
-- LOCN 50 250 true
-- STYLE 
--
listToPic xs =
  case xs of {
    []     -> nilCell;
    x:xs   -> Super (consCell x) 
                    (trans (listToPic xs))
  }
                
--
-- LOCN 50 275 true
-- STYLE 
--
nilCell = Rect dx6 ch bodyColor edgeColor
--
-- LOCN 50 525 true
-- STYLE Hide
--
nilCell :: Pic
--
-- LOCN 50 500 true
-- STYLE 
--
trans :: Pic -> Pic
--
-- LOCN 50 400 true
-- STYLE 
--
trans pic = Trans dx5 0 pic
--
-- LOCN 50 425 true
-- STYLE 
--
instance Edit (a -> b) where
  style f = Hide
--
-- LOCN 700 250 true
-- STYLE 
--
instance Edit Pic where
  style pic = Picture
--
-- LOCN 700 300 true
-- STYLE 
--
consCell :: a -> Pic
--
-- LOCN 50 575 true
-- STYLE 
--
consCell x =
  Trans 0 dy3 (Line dx5 0 linkColor)  <+>
  Rect dx4 ch bodyColor edgeColor     <+>
  let field = SelRect (dx3-dx1) (2*dy2) 
                      fieldBodyColor fieldEdgeColor
  in  Trans dx1 (dy3-dy2) field       <+>
  let text = PicText fmt (show x) 
  in Trans dx2 (dy3+dy1) text
  
--
-- LOCN 50 600 true
-- STYLE 
--
bodyColor = gray
--
-- LOCN 750 425 true
-- STYLE Hide
--
edgeColor = red
--
-- LOCN 750 450 true
-- STYLE Hide
--
(<+>) = Super
--
-- LOCN 700 350 true
-- STYLE Hide
--
listToPic [1,20,300, 4000]
--
-- LOCN 50 950 true
-- STYLE 
--
linkColor = gray
--
-- LOCN 750 475 true
-- STYLE Hide
--
dx1 = 2
--
-- LOCN 550 575 true
-- STYLE Hide
--
dx2 = dx1 + 2
--
-- LOCN 550 600 true
-- STYLE Hide
--
dx4 = dx3 + 30
--
-- LOCN 550 650 true
-- STYLE Hide
--
dx5 = dx4 + 50
--
-- LOCN 550 675 true
-- STYLE Hide
--
dy2 = dy1 + 2
--
-- LOCN 800 600 true
-- STYLE Hide
--
dy3 = dy2 + 2
--
-- LOCN 800 625 true
-- STYLE Hide
--
ch = dy3 + dy3
--
-- LOCN 800 650 true
-- STYLE Hide
--
dx6 = ch
--
-- LOCN 550 700 true
-- STYLE Hide
--
fieldColor = white
--
-- LOCN 750 500 true
-- STYLE Hide
--
fieldBodyColor = white
--
-- LOCN 750 525 true
-- STYLE Hide
--
fieldEdgeColor = black
--
-- LOCN 750 550 true
-- STYLE Hide
--
fmt = Format SansSerif ptSize darkGray False False
--
-- LOCN 550 775 true
-- STYLE Hide
--
fontHeight = snd (fontSize fmt)
--
-- LOCN 850 800 true
-- STYLE 
--
dy1 = fontHeight `div` 2
--
-- LOCN 550 875 true
-- STYLE Hide
--
ptSize = 12
--
-- LOCN 550 750 true
-- STYLE Hide
--
fontWidth = fst (fontSize fmt)
--
-- LOCN 550 800 true
-- STYLE 
--
dx3 = (2 * fontWidth) + dx1
--
-- LOCN 550 900 true
-- STYLE Hide
--
arrayToPic :: [[a]] -> Pic
--
-- LOCN 50 1050 true
-- STYLE 
--
arrayToPic xss =
  case xss of {
    []      -> NoPic;
    xs:xss  -> listToPic xs <+> Trans 0 dy10 (arrayToPic xss)
  }
--
-- LOCN 50 1075 true
-- STYLE 
--
dy10 = 2 * ch
--
-- LOCN 800 675 true
-- STYLE Hide
--
tri =[ [i*j| j <- [1 .. i]] | i <- [1 ..]]
--
-- LOCN 50 1225 true
-- STYLE Hide
--
tri :: [[Int]]
--
-- LOCN 50 1200 true
-- STYLE 
--
arrayToPic tri
--
-- LOCN 800 1500 true
-- STYLE 
--
tri
--
-- LOCN 50 1275 true
-- STYLE table2
