-- Vital 2.1
--
p1 = Rect 100 30 yellow red
--
-- LOCN 43 142 true
-- STYLE Picture
--
p2 =   SelRect 30 100 cyan blue
--
-- LOCN 305 143 true
-- STYLE Picture
--
instance Edit Pic where
  edit p path = [("Info", fInfo),
                 ("Flip", fFlip)]
--
-- LOCN 612 150 true
-- STYLE 
--
p' = let p = Super p1 p2
     in p `Super` (Trans 40 40 p)
--
-- LOCN 44 351 true
-- STYLE Picture
--
import SS
--
-- LOCN 675 50 true
-- STYLE 
{-
Demo of selectable picture components
-}
-- LOCN 50 50 true
-- STYLE title
{-
An ordinary rectangle
-}
-- LOCN 50 100 true
-- STYLE comment
{-
A selectable rectangle
-}
-- LOCN 300 100 true
-- STYLE comment
{-
A compound picture
-}
-- LOCN 50 325 true
-- STYLE comment
{-
Definition of some operations on pictures
-}
-- LOCN 600 100 true
-- STYLE comment
--
flip p = 
  case p of {
    Rect w h c c'    -> Rect h w c' c;
    SelRect w h c c' -> SelRect h w c' c;
    Trans x y p      -> Trans y x p;
    Super p1 p2      -> Super (flip p1) (flip p2)
  }
--
-- LOCN 625 400 true
-- STYLE Hide
{-
A helper function
-}
-- LOCN 625 375 true
-- STYLE comment
--
fInfo pic path lhs rhs clip =
  (Nothing, Nothing, Just ("Path is: " ++ show path))
--
-- LOCN 614 219 true
-- STYLE Hide
--
fFlip pic path lhs rhs clip =
  let text = "flip (" ++ rhs ++ ")"
   in (Just text, Nothing, Just "Picture flipped!")
--
-- LOCN 614 280 true
-- STYLE Hide
{-
Very simple demo of the "SelRect"  (selectable rectangles) picture constructor.
-}
-- LOCN 50 -50 true
-- STYLE abstract
