-- Vital 2.1
{-
Creating simple pictures
-}
-- LOCN 50 50 true
-- STYLE title
--
import Pictures
--
-- LOCN 750 100 true
-- STYLE 
--
sq = Rect 40 40 yellow gray
--
-- LOCN 50 375 true
-- STYLE Picture
--
circ = Ellipse 30 30 cyan blue
--
-- LOCN 600 375 true
-- STYLE Picture
--
poly = let vs = [(10,30), (30,30), (30,10), (10,5), (20, 15)]
       in Poly vs lightGray red
--
-- LOCN 50 500 true
-- STYLE Picture
--
withAxes poly
--
-- LOCN 450 925 true
-- STYLE Picture
--
withBB poly
--
-- LOCN 550 1700 true
-- STYLE Picture
{-
For example, here are some simple pictures:
-}
-- LOCN 50 275 true
-- STYLE comment
--
none = NoPic
--
-- LOCN 600 550 true
-- STYLE Picture
{-
Notice that there is not very much to see for this last 
picture!  But, nevertheless, it is a perfectly valid value 
of type Pic  (just as 0 is a perfectly valid value of 
type Int).
-}
-- LOCN 600 625 true
-- STYLE comment
{-
Exercise 1.1
-}
-- LOCN 50 700 true
-- STYLE open2 "PicEx_1_1"
{-
Simple pictures can be formed using these basic constructors 
    Rect     :: Int -> Int   -> Color -> Color -> Pic
    Ellipse  :: Int -> Int   -> Color -> Color -> Pic
    Poly     :: [(Int, Int)] -> Color -> Color -> Pic
    NoPic    ::                                   Pic
-}
-- LOCN 50 125 true
-- STYLE comment
--
sq, circ, poly, none :: Pic
--
-- LOCN 50 325 true
-- STYLE 
--
import SS
--
-- LOCN 750 50 true
-- STYLE 
{-
Often it is useful to be able to see where a picture lies with respect to its local origin. The function
      withAxes :: Pic -> Pic

function takes a picture and superimposes its axes on it. For example:
-}
-- LOCN 50 775 true
-- STYLE comment
--
withAxes circ
--
-- LOCN 50 925 true
-- STYLE Picture
{-
Often, we need to move a picture sideways (or, more accurately stated, we need to be able to
generate a new picture value similar to the given one, apart from its position). The following function
does just this:
      move :: Int -> Int -> Pic -> Pic
-}
-- LOCN 50 1075 true
-- STYLE comment
{-
For example:
-}
-- LOCN 50 1250 true
-- STYLE comment
--
circ2 = move 100 20 circ
--
-- LOCN 50 1300 true
-- STYLE Picture
--
withAxes circ2
--
-- LOCN 450 1300 true
-- STYLE Picture
--
withBB circ
--
-- LOCN 100 1700 true
-- STYLE Picture
{-
A useful concept is the "bounding box" of a picture. This is defined as the smallest rectangle
that contains all of the picture. The bounding box of a picture can be superimposed
on a picture using the function
      withBB :: Pic -> Pic
-}
-- LOCN 50 1500 true
-- STYLE comment
{-
For example
-}
-- LOCN 50 1625 true
-- STYLE comment
--
withBB circ2
--
-- LOCN 275 1700 true
-- STYLE Picture
{-
Exercise 1.2
-}
-- LOCN 50 2050 true
-- STYLE open2 "PicEx_1_2"
--
bBox circ
--
-- LOCN 100 2000 true
-- STYLE ts2
{-
Alternatively, the bounding box of a function can be displayed in numerical form, using
the function
      bBox :: Pic -> Maybe (Int, Int, Int, Int)
-}
-- LOCN 50 1850 true
-- STYLE comment
{-
For example
-}
-- LOCN 50 1950 true
-- STYLE comment
--
bBox circ2
--
-- LOCN 300 2000 true
-- STYLE ts2
--
bBox poly
--
-- LOCN 575 2000 true
-- STYLE ts2
{-
Back to previous document
-}
-- LOCN 50 2175 true
-- STYLE open1 ""
{-
Back to previous document
-}
-- LOCN 750 150 true
-- STYLE open1 ""
{-
Illustration of how to create simple pictures, how to translate them
and how to compute their bounding boxes.
-}
-- LOCN 50 -50 true
-- STYLE abstract
--
import SSExercises
--
-- LOCN 750 75 true
-- STYLE 
