-- Vital 2.1
{-
Sorted powerset
-}
-- LOCN 75 75 true
-- STYLE title 
--
ps :: [a] -> [[[a]]]
--
-- LOCN 75 275 true
-- STYLE     
--
ps xs =
    case xs of {
      []    -> [[[]]];
      x:xs  -> [[]] : myzip x (ps xs)
    }
--
-- LOCN 75 325 true
-- STYLE Hide
--
myzip :: a -> [[[a]]] -> [[[a]]]
--
-- LOCN 75 425 true
-- STYLE     
--
myzip x yss = 
    case yss of {
      as:[]  ->  [map (x:) as];
      as:bss  ->  (map (x:) as ++ head bss) : myzip x bss
    }
--
-- LOCN 75 474 true
-- STYLE Hide
--
powerset = concat . ps
--
-- LOCN 75 725 true
-- STYLE Hide
--
powerset [1 .. 4]
--
-- LOCN 75 925 true
-- STYLE table2'
--
powerset [1 .. 8]
--
-- LOCN 75 1075 true
-- STYLE table2'
--
powerset [1 .. 100]
--
-- LOCN 75 1275 true
-- STYLE table2'
--
import SS
--
-- LOCN 675 50 true
-- STYLE   
{-
A nice algorithm to generate the powerset of a list of items. Unlike other, more obvious
algorithms for this task, this algorithm enumerates the elements in a lexicographically
sorted order. (Algorithm due to Christian Maedar  [Haskell mail list 10.6.03])
-}
-- LOCN 75 175 true
-- STYLE comment
{-
The top-level function
-}
-- LOCN 75 625 true
-- STYLE comment
--
powerset :: [a] -> [[a]]
--
-- LOCN 75 675 true
-- STYLE 
{-
Some examples
-}
-- LOCN 75 825 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 75 1375 true
-- STYLE open ""
{-
Back to previous document
-}
-- LOCN 677 90 true
-- STYLE open ""
{-
An algorithm that enumerates the elements of the powerset of
a list in a lexicographically sorted order.
-}
-- LOCN 75 -50 true
-- STYLE abstract
