-- Vital 2.1
{-
Perspective views of large lists
-}
-- LOCN 75 75 true
-- STYLE title
{-
The following function is a traditional way of computing the prime numbers. 
-}
-- LOCN 75 175 true
-- STYLE comment
--
sieve ns = let {m = head ns; ms = tail ns}
           in m : sieve [ n | n <- ms, n `mod` m /= 0]
--
-- LOCN 75 225 true
-- STYLE hide
{-
The (infinite) sequence of prime numbers may be viewed either as a plain list (below) or, by
pressing the PV button on the toolbar, it may be rendered as a Perspective View. 
-}
-- LOCN 75 325 true
-- STYLE comment
--
primes = sieve [2 ..]
--
-- LOCN 75 575 true
-- STYLE 
--
import SS
--
-- LOCN 775 75 true
-- STYLE 
{-
Back to previous document
-}
-- LOCN 775 125 true
-- STYLE open1 ""
{-
The list may be traversed by rotating the mouse wheel.
Its head may be repositioned by dragging with the mouse.
-}
-- LOCN 75 400 true
-- STYLE warning2
{-
Back to previous document
-}
-- LOCN 75 700 true
-- STYLE open1 ""
{-
T h e  S i e v e   o f   E r a t o s t h e n e s  (c. 200 BCE)
-}
-- LOCN 75 525 true
-- STYLE heading2
{-
Illustration of the 'perspective view' facility that allows large or infinite lists to
be displayed as a perspective view, vanishing into the distance.
-}
-- LOCN 75 -50 true
-- STYLE abstract
{-
An unconventional way of generating
a quarter of a million prime numbers . . .
-}
-- LOCN 775 175 true
-- STYLE open1 "Primes1"
