-- Vital 2.1
{-
Fast primes
-}
-- LOCN 50 50 true
-- STYLE title
--
import SS
--
-- LOCN 850 125 true
-- STYLE 
--
ns = 0 : ns'
--
-- LOCN 50 300 true
-- STYLE list1
--
ms = addList ns ns'
--
-- LOCN 50 425 true
-- STYLE hide
--
ns' = 2 : 3 : ms
--
-- LOCN 50 375 true
-- STYLE hide
--
addList ms ns =
  case (ms, ns) of
    (m:ms, n:ns) -> m+n : addList ms ns
--
-- LOCN 50 675 true
-- STYLE 
--
filterFactor n ms =
  case ms of
    m : ms -> let es = filterFactor (n+1) ms
              in if m `mod` n == 0 then n : es else es
--
-- LOCN 50 800 true
-- STYLE 
--
ps = filterFactor 1 ns
--
-- LOCN 50 475 true
-- STYLE list2
{-
Let a[n] be the series defined by:

    a[n] = a[n-2] + a[n-3]

with
    a[1] = 0,  a[2] = 2,  a[3] = 3,  
-}
-- LOCN 50 125 true
-- STYLE commentB
{-
Assertion:

      isPrime n   <===>   n divides a[n]

for n = 1, 2, ..., (521^2)
-}
-- LOCN 450 125 true
-- STYLE commentB
{-
(The sequence could, of course, be defined in terms
 of the usual combinators (zip, map, filter) but such
 an implementation sacrifies a degree of efficiency . . .)
-}
-- LOCN 600 650 true
-- STYLE comment
--
addList :: [Int] -> [Int] -> [Int]
--
-- LOCN 50 650 true
-- STYLE 
--
filterFactor :: Int -> [Int] -> [Int]
--
-- LOCN 50 775 true
-- STYLE 
{-
Example contributed by Chris Woodcock
-}
-- LOCN 50 925 true
-- STYLE comment
{-
The first quarter of a million primes can be generated by a simple recurrence relation.
-}
-- LOCN 50 -50 true
-- STYLE abstract
