-- Vital 2.1
--
import SS
--
-- LOCN 850 75 true
-- STYLE 
{-
The Rationals
-}
-- LOCN 50 75 true
-- STYLE title
--
rats = [ [i % j | i <- [1 .. (j-1)]] | j <- [2 .. ]]
--
-- LOCN 50 425 true
-- STYLE Hide
--
import Ratio
--
-- LOCN 850 100 true
-- STYLE 
--
take 8 rats
--
-- LOCN 50 625 true
-- STYLE table1
--
decimalRats = map decimal (concat rats')
--
-- LOCN 50 1525 true
-- STYLE ts
--
decimalRats
--
-- LOCN 50 1775 true
-- STYLE bareList' 0 20 ts'
--
rats' = [ [i % j | i <- [1 .. (j-1)], (gcd i j == 1)] | j <- [2 .. ]]
--
-- LOCN 50 950 true
-- STYLE ts
--
rats
--
-- LOCN 50 475 true
-- STYLE ts
{-
Rational numbers are formed, and displayed, using the "%" operator (as defined in
the "Ratio" library module). For example:
-}
-- LOCN 50 175 true
-- STYLE comment
--
7 % 12
--
-- LOCN 50 250 true
-- STYLE ts
--
8 % 12
--
-- LOCN 275 250 true
-- STYLE ts
{-
The infinite sequence of rational numbers can be defined as
-}
-- LOCN 50 375 true
-- STYLE comment
{-
or, displayed in tabular form, as
-}
-- LOCN 50 575 true
-- STYLE comment
{-
A more useful definition of the sequence of rationals is obtained if duplicated elements in the sequence are
eliminated. This can easily be done by filtering out pairs whose elements are not mutually prime:
-}
-- LOCN 50 875 true
-- STYLE comment
{-
Decimal expansions of rational numbers
-}
-- LOCN 50 1125 true
-- STYLE heading1
{-
This function:
    decimal :: Rat -> String
(defined in the Ratio library module) expresses a rational as a decimal numeral. For example:
-}
-- LOCN 50 1200 true
-- STYLE comment
--
decimal (2 % 5)
--
-- LOCN 50 1300 true
-- STYLE ts'
{-
But, since some rationals have numerals of infinite length, attempting to display the
sequence of rationals in 1-dimensional form will not yield useful results:
-}
-- LOCN 50 1450 true
-- STYLE comment
{-
However, by displaying the same sequence in tabular form, this problem is overcome:
-}
-- LOCN 50 1700 true
-- STYLE comment
{-
Drag the document sideways or upwards to 
explore further regions of this table . . .
-}
-- LOCN 350 1900 true
-- STYLE warning2
{-
Back to previous document
-}
-- LOCN 700 1750 true
-- STYLE open1 ""
{-
Back to previous document
-}
-- LOCN 500 75 true
-- STYLE open ""
--
fmt = Format SansSerif 15 black False False
--
-- LOCN 850 150 true
-- STYLE Hide
--
ts  = Text 1 fmt
--
-- LOCN 850 175 true
-- STYLE Hide
--
ts' = Text 0 fmt
--
-- LOCN 850 200 true
-- STYLE Hide
{-
Discussion about how the rationals can be enumerated and a 
demo of the advantages that demand-driven lazy evaluation offers
for displaying a 2-D infinite array of the decimal expansions
of the rationals.
-}
-- LOCN 50 -75 true
-- STYLE abstract
