-- Vital 2.1
--
import RelLib
--
-- LOCN 650 50 true
-- STYLE 
--
eg1 = mkRel [(3,5), (0,3), (0,2)]
--
-- LOCN 75 350 true
-- STYLE 
--
import SS
--
-- LOCN 650 25 true
-- STYLE 
{-
Direct Manipulation of an ADT
-}
-- LOCN 50 50 true
-- STYLE title
{-
Direct manipulation of sets
-}
-- LOCN 575 875 true
-- STYLE open "SetDemo"
{-
Back to previous document
-}
-- LOCN 100 1025 true
-- STYLE open1 ""
{-
Exercise!
Try carrying out some of the following operations on these relations (and noticing the way that their declarations
are updated to reflect the user's intentions):
  - select (by double-clicking) an element of the underlying set;
  - drop-down (by right-clicking) a menu of possible operations involving that element, and select the "Mark" operation
  - select another element of the set, drop-down a menu, and add or delete an edge to the picture of the relation;
  - select (by double-clicking within one of the relations, but not on an element) the entire relation;
  - drop-down a menu of possible operations on the relation, or between the relation and the clipboard.
-}
-- LOCN 50 625 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 800 100 true
-- STYLE open ""
{-
The "Edit" class provides methods that allow the "look and feel" of an arbitrary ADT to be defined, viz:
  - the default style that is used to display values of that type, and
  - the way that its values respond to mouse gestures.
As with the built-in "Copy" and "Paste" commands, these methods do not operate directly on the value
of an ADT but rather they synthesis new Haskell declarations that have the desired effect.
-}
-- LOCN 50 100 true
-- STYLE comment
{-
As an example of the use of the "Edit" class, this document imports a library module ("RelLib") which
implements an ADT for "binary relations on a set", and defines the style used for depicting them and a
menu of "point & click" mouse operations that the user can carry out on them.
-}
-- LOCN 50 225 true
-- STYLE comment
{-
Here are a couple of such relations (defined on the set {A, B, ..., H}):
-}
-- LOCN 50 300 true
-- STYLE comment
--
eg1, eg2 :: Rel
--
-- LOCN 75 325 true
-- STYLE 
--
eg2 = emptyRel
--
-- LOCN 475 375 true
-- STYLE 
{-
More about the "Edit" class:
-}
-- LOCN 50 825 true
-- STYLE comment
{-
How to define the style of an ADT
-}
-- LOCN 100 875 true
-- STYLE open "EditStyleDemo"
{-
How to define a menu of operations for an ADT
-}
-- LOCN 100 925 true
-- STYLE open "EditEditDemo"
{-
How to define an "adjustment" operation for an ADT
-}
-- LOCN 100 975 true
-- STYLE open "EditAdjustDemo"
{-
NB: Can use the
"Undo" button to
undo changes.
-}
-- LOCN 825 475 true
-- STYLE warning2
{-
A similar example (involving sets rather than relations):
-}
-- LOCN 525 825 true
-- STYLE comment
{-
As an example of the use of the "Edit" class, this document imports a library module ("RelLib") which
implements an ADT for "binary relations on a set", and defines the style used for depicting them and a
menu of "point & click" mouse operations that the user can carry out on them.
-}
-- LOCN 50 -100 true
-- STYLE abstract
