-- Vital 2.1
--
import SS
--
-- LOCN 725 100 true
-- STYLE 
--
import RowGameLib
--
-- LOCN 25 250 true
-- STYLE 
{-
Simple game, illustrating secure, 
direct manipulation of an ADT
-}
-- LOCN 25 100 true
-- STYLE title
--
initPos
--
-- LOCN 25 300 true
-- STYLE posStyle
--
instance Edit Position where {
  edit pos path = 
        [("Lift", fLift), ("Drop", fDrop), ("Show score", fScore)]
}
--
-- LOCN 25 425 true
-- STYLE 
--
fDrop pos path x y lhs rhs clip =
  let { i = length path - 2;
        verdict = checkDrop i pos;
        sExp = "dropIt " ++ shows i (paren rhs)
  } in case verdict of {
         Left message ->
           (Nothing, Nothing, Just message);
         Right message ->
           (Just sExp, Nothing, Just "Piece has been placed")
       }
--
-- LOCN 25 700 true
-- STYLE Hide
--
fLift pos path x y lhs rhs clip =
  let { i = length path - 2;
        verdict = checkLift i pos;
        sExp = "liftIt " ++ shows i (paren rhs)
  } in case verdict of {
         Left message ->
           (Nothing, Nothing, Just message);
         Right message ->
           (Just sExp, Nothing, Just "Piece has been lifted")
       }
--
-- LOCN 25 525 true
-- STYLE Hide
--
fScore pos path x y lhs rhs clip =
   (Nothing, Nothing, Just (score pos))
--
-- LOCN 25 875 true
-- STYLE Hide
--
paren s = " (" ++ s ++ ") "
--
-- LOCN 25 925 true
-- STYLE Hide
{-
A simple game. Double-click to select a square,
then right-click to drop down a menu. Aim of 
the game is to move the tokens to minimise
the score.
-}
-- LOCN 600 300 true
-- STYLE warning2
{-
An early trial of the Edit.edit method: a simple board is displayed and the
object is to move the tokens around so as to minimise the score.
-}
-- LOCN 25 -50 true
-- STYLE abstract
