-- Vital 2.1
--
import SonySS
--
-- LOCN 825 75 true
-- STYLE 
{-
Recap: displaying and manipulating algebraic types
-}
-- LOCN 25 75 true
-- STYLE title
{-
The way that values are displayed is determined by "style" expressions
-}
-- LOCN 75 225 true
-- STYLE comment2
{-
For example, a user-defined algebraic type such as
-}
-- LOCN 75 375 true
-- STYLE comment2
--
data Tree = Tip Int
          | Node Tree Tree
--
-- LOCN 127 497 true
-- STYLE 
--
tree = Node (Tip 3) (Node (Tip 4) (Tip 5))
--
-- LOCN 550 500 true
-- STYLE Hide
{-
. . . can be displayed as:
-}
-- LOCN 75 625 true
-- STYLE comment2
--
tree
--
-- LOCN 200 700 true
-- STYLE 
--
tree
--
-- LOCN 200 900 true
-- STYLE myBlueStyle
--
tree
--
-- LOCN 625 800 true
-- STYLE myYellowStyle'
--
myBlueStyle    = treeStyle True False 20 15 12 white blue gray
--
-- LOCN 175 1225 true
-- STYLE Hide
--
myYellowStyle' = treeStyle False True 40 20 15 blue yellow magenta
--
-- LOCN 175 1300 true
-- STYLE Hide
{-
Values can be manipulated using Copy/Paste operations . . .
(just as with spreadsheets!)
-}
-- LOCN 75 1500 true
-- STYLE comment2
{-
Persistence:  
  - note that it is the Haskell code itself that is updated
  - and hence (indirectly) also the value

This gives persistence/portability
-}
-- LOCN 75 1925 true
-- STYLE comment2
{-
      - tedious to have to supply styles

      - fixed repetoire of operations {Copy, Paste}

     - limited to concrete types (no ADTs)

     - purely static images (no multimedia)
-}
-- LOCN 75 2325 true
-- STYLE comment2
{-
Back to main document
-}
-- LOCN 50 2575 true
-- STYLE open1 ""
{-
The different representations are defined
by  "Style" expressions
-}
-- LOCN 75 1125 true
-- STYLE comment2
--
tree
--
-- LOCN 200 1600 true
-- STYLE yellowTree'
--
tree1 = (Node (Node (Tip 20) (Tip 30)) (Tip 40))
--
-- LOCN 700 1600 true
-- STYLE yellowTree'
{-
Limitations
-}
-- LOCN 75 2225 true
-- STYLE comment1
--
title = enlarge comment1
--
-- LOCN 25 -50 true
-- STYLE Hide
