-- Vital 2.1
--
import SonySS
--
-- LOCN 825 75 true
-- STYLE 
{-
Implicit style selection using type classes
-}
-- LOCN 25 75 true
-- STYLE title
{-
Can use the Haskell type class mechanism to select styles.
-}
-- LOCN 75 250 true
-- STYLE comment2
{-
By analogy, the "Show" class allows a user to define a "show" method for each type:
-}
-- LOCN 75 425 true
-- STYLE comment2
{-
class Show a where 
  show :: a -> String
-}
-- LOCN 125 575 true
-- STYLE commentCode
{-
instance (Show a, Show b) => Show (a, b) where
  show (x, y) = "(" ++ show x ++ ", " ++ show y ++ ")"
-}
-- LOCN 125 725 true
-- STYLE commentCode
{-
So we introduce a new type class for defining the style to
use with each type:
-}
-- LOCN 75 1075 true
-- STYLE comment2
{-
class Edit a where 
  style :: a -> Style
-}
-- LOCN 125 1250 true
-- STYLE commentCode
{-
. . . and instance definitions for the types we want to display.   For example:
-}
-- LOCN 75 1450 true
-- STYLE comment2
--
instance (Edit a) => Edit (Tree a) where
  style tr = myTreeStyle
--
-- LOCN 75 1775 true
-- STYLE commentCode
{-
Then, by default, all values of type Tree will automatically be shown in this style
-}
-- LOCN 75 1950 true
-- STYLE comment2
--
data Tree = Tip Int
          | Node Tree Tree
--
-- LOCN 550 1575 true
-- STYLE 
--
tree = Node (Tip "abc") (Node (Tip "def") (Tip "ghi"))
--
-- LOCN 650 2125 true
-- STYLE 
--
myTreeStyle = 
  treeStyle False True 50 20 12 red lightYellow gray
--
-- LOCN 550 1650 true
-- STYLE Hide
--
Node (Tip 33) (Tip 44)
--
-- LOCN 200 2125 true
-- STYLE 
--
(2.0 * pi, True)
--
-- LOCN 125 875 true
-- STYLE 
{-
Back to main document
-}
-- LOCN 75 2400 true
-- STYLE open1 ""
--
title = enlarge comment1
--
-- LOCN 25 -50 true
-- STYLE Hide
