-- Vital 2.1
--
import SonySS
--
-- LOCN 825 75 true
-- STYLE 
{-
Animation
-}
-- LOCN 50 75 true
-- STYLE title
{-
Aim: simplicity for the user.
-}
-- LOCN 100 225 true
-- STYLE comment2
{-
The "Animation" style takes a value of type

        Time  ->  Pic

where

        type Time = Int          -- (in milli-seconds)

and renders it as an animated picture.
-}
-- LOCN 100 425 true
-- STYLE comment2
{-
NB: Need to set the mode
to "Anim"
-}
-- LOCN 675 1000 true
-- STYLE shrink comment2
{-
For example
-}
-- LOCN 100 800 true
-- STYLE comment2
--
box t = let w = (t `div` 10) `mod` 500
        in Rect w 20 yellow red 
--
-- LOCN 100 975 true
-- STYLE Hide
--
box :: Time -> Pic
--
-- LOCN 100 900 true
-- STYLE 
--
Animation box
--
-- LOCN 100 1125 true
-- STYLE Picture
{-
Note: this does not compromise "declarative" semantics since the
user has no direct access to the time-varying value of real time.
-}
-- LOCN 100 1375 true
-- STYLE comment2
--
Animation (box . (* 2))
--
-- LOCN 100 1900 true
-- STYLE Picture
{-
Can alter animation rate by composition with scaling function
-}
-- LOCN 100 1625 true
-- STYLE comment2
{-
The "Graphics" library provides floating-point graphics functions
-}
-- LOCN 100 2150 true
-- STYLE comment2
--
import Graphics
--
-- LOCN 100 2225 true
-- STYLE 
--
polar theta = let r = 50.0 
              in line 0.0 0.0 (r * cos theta) (r * sin theta) red
--
-- LOCN 100 2400 true
-- STYLE Hide
--
animate 1.0 polar
--
-- LOCN 100 2575 true
-- STYLE Picture
--
animate (-1.0) polar
--
-- LOCN 400 2575 true
-- STYLE Picture
--
animate 2.0 polar
--
-- LOCN 700 2575 true
-- STYLE Picture
--
waveform :: Int -> Int -> (Double -> Pic)
--
-- LOCN 100 2900 true
-- STYLE 
--
waveform dx n phase =
  Poly ((dx*(n-1),0) : ((0,0) : [let { x = dx * i;
              theta = (2.0 * pi * fromInt i / fromInt n) + phase;
              y = - round (100.0 * (sin theta + (0.6 * sin (2.8 * theta))))
        } in (x, y) | i <- [0 .. (n-1)]])) cyan blue
--
-- LOCN 100 3025 true
-- STYLE Hide
--
animate 0.3 (waveform 10 50)
--
-- LOCN 50 3375 true
-- STYLE Picture
{-
Waveforms . . .
-}
-- LOCN 100 2800 true
-- STYLE comment2
--
animate (-0.1) (waveform 10 50)
--
-- LOCN 600 3375 true
-- STYLE Picture
{-
Back to main document
-}
-- LOCN 75 3750 true
-- STYLE open1 ""
{-
Gear trains
-}
-- LOCN 300 3650 true
-- STYLE open1 "V2"
{-
Heat pump
-}
-- LOCN 75 3650 true
-- STYLE open1 "V3"
--
Animation box
--
-- LOCN 100 1750 true
-- STYLE Picture
--
title = enlarge comment1
--
-- LOCN 50 -50 true
-- STYLE Hide
