-- Vital 2.1
--
import SonySS
--
-- LOCN 825 75 true
-- STYLE 
{-
Interaction
-}
-- LOCN 50 75 true
-- STYLE title
{-
"Animations" are stateless:

           f  time ---> pic
-}
-- LOCN 100 225 true
-- STYLE comment2
--
import Graphics
--
-- LOCN 825 100 true
-- STYLE 
{-
"Interactions" are statefull - and also have access to mouse controls

        f   time  x  y  p  state ---->  (state',  pic)
-}
-- LOCN 100 675 true
-- STYLE comment2
{-
Here is an example: 

    - a dot attacted towards the cursor

    - the "state" is the current position of the cursor

    - clicking the mouse resets the position of the dot
-}
-- LOCN 100 925 true
-- STYLE comment2
--
attractor t x y p s =
  let {u = fromInt x;  v = fromInt y;
       x' = (k * fst s) + ((1.0 - k) * u);
       y' = (k * snd s) + ((1.0 - k) * v);
       s' = if p then (u, v) else (x', y');
       pic = circle x' y' 10.0 green black
  } in (s', pic)
--
-- LOCN 100 1550 true
-- STYLE Hide
--
import Graphics
--
-- LOCN 750 1100 true
-- STYLE 
--
Interaction s0 attractor
--
-- LOCN 100 2250 true
-- STYLE Picture
--
attractor :: Time -> Int -> Int -> Bool -> State -> (State, Pic)
--
-- LOCN 100 1475 true
-- STYLE 
--
type State = (Double, Double)
--
-- LOCN 100 1225 true
-- STYLE 
--
s0 :: State
--
-- LOCN 100 1850 true
-- STYLE 
--
s0 = (100.0, 100.0)
--
-- LOCN 100 1925 true
-- STYLE Hide
{-
Run the interaction
-}
-- LOCN 100 2125 true
-- STYLE comment2
--
Animation  (\t -> PicText fmt (show (div t 1000)))

--
-- LOCN 100 450 true
-- STYLE Picture
--
fmt = Format SansSerif 24 red True False
--
-- LOCN 625 450 true
-- STYLE Hide
{-
The "next-state" function
-}
-- LOCN 100 1350 true
-- STYLE comment2
{-
The initial state
-}
-- LOCN 100 1775 true
-- STYLE comment2
--
k = 0.98
--
-- LOCN 700 1575 true
-- STYLE Hide
{-
A more elaborate example
-}
-- LOCN 50 2450 true
-- STYLE comment1
{-
Back to main document
-}
-- LOCN 100 3100 true
-- STYLE open1 ""
--
import DotGameLib
--
-- LOCN 102 2535 true
-- STYLE 
--
Interaction initState game
--
-- LOCN 102 2585 true
-- STYLE Picture
--
title = enlarge comment1
--
-- LOCN 50 -75 true
-- STYLE Hide
