-- Vital 2.1
--
import SS
--
-- LOCN 700 50 true
-- STYLE 
--
import Graphics
--
-- LOCN 700 75 true
-- STYLE 
{-
Scrolling waveforms
-}
-- LOCN 50 75 true
-- STYLE title
{-
The Graphics library module defines a function
      waveform :: (Double -> Double) -> Double -> Pic
that yields a picture of the graph of a function on the domain (0, 2pi) at a given phase.
-}
-- LOCN 50 150 true
-- STYLE comment
{-
For example, this expression displays one waveform (2pi radians) of the sine
function with a zero phase shift:
-}
-- LOCN 50 225 true
-- STYLE comment
--
waveform sin 0.0






--
-- LOCN 75 300 true
-- STYLE Picture
{-
Press the "Anim" button on the
toolbar for animation
-}
-- LOCN 650 700 true
-- STYLE warning2
{-
. . . and here is the definition of a 1.5 Hz carrier amplitude modulated by a 0.2 Hz sinewave signal:
-}
-- LOCN 50 1100 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 50 1950 true
-- STYLE open ""
{-
Back to previous document
-}
-- LOCN 700 150 true
-- STYLE open ""
{-
For example, here is the sine wave animated at a rate of 0.2 Hz:
-}
-- LOCN 50 775 true
-- STYLE comment
--
animWaveform 0.2 sin






--
-- LOCN 75 825 true
-- STYLE Picture
{-
An animated version of this function may be defined by putting it together with the 'animate' function:
    animate :: Double -> (Double -> Pic) -> Pic
(also defined in the Graphics module):
-}
-- LOCN 50 550 true
-- STYLE comment
--
animWaveform :: Double -> (Double -> Double) -> Pic
--
-- LOCN 75 650 true
-- STYLE 
--
animWaveform freq = (animate freq) . waveform
--
-- LOCN 75 700 true
-- STYLE Hide
--
f t = let {signal    = sin (0.2 * t);
           carrier   = sin (1.5 * t);
           amplitude = 0.5 * (1.0 + signal)
      } in amplitude * carrier
--
-- LOCN 75 1150 true
-- STYLE Hide
--
animWaveform 1.0 f






--
-- LOCN 75 1300 true
-- STYLE Picture
{-
. . . which looks like:
-}
-- LOCN 50 1250 true
-- STYLE comment
{-
. . . and one animated at a rate of - 0.1 Hz
-}
-- LOCN 525 775 true
-- STYLE comment
--
animWaveform (- 0.1) sin






--
-- LOCN 550 825 true
-- STYLE Picture
--
squareWave t = let {harmonic1 = sin t;
                    harmonic3 = sin (3.0 * t) / 3.0;
                    harmonic5 = sin (5.0 * t) / 15.0
               } in harmonic1 + harmonic3 + harmonic5
--
-- LOCN 75 1600 true
-- STYLE Hide
--
animWaveform 0.1 squareWave






--
-- LOCN 75 1700 true
-- STYLE Picture
{-
. . . and here is a 5rd order Fourier approximation to a square wave:
-}
-- LOCN 50 1550 true
-- STYLE comment
{-
Illustration of using the "waveform" function from the Graphics library to
diplay scrolling waveforms.
-}
-- LOCN 50 -50 true
-- STYLE abstract
