-- Vital 2.1
--
import SS
--
-- LOCN 750 50 true
-- STYLE 
{-
DNA and the Genetic Code
-}
-- LOCN 50 100 true
-- STYLE title
{-
A case study, illustrating the nature of DNA, using definitions from the DNA_lib module.
-}
-- LOCN 50 -75 true
-- STYLE abstract
--
import DNA_lib
--
-- LOCN 50 150 true
-- STYLE 
--
seq = "ATCG   ATG ACT GGG TAG GGAA"
--
-- LOCN 50 225 true
-- STYLE hide
{-
Back to previous document
-}
-- LOCN 750 100 true
-- STYLE open1 ""
{-
The DNA_lib module
-}
-- LOCN 750 200 true
-- STYLE openLib "DNA_lib"
{-
Extended exposition of DNA
and the Genetic Code
-}
-- LOCN 750 150 true
-- STYLE open "DNA_DEVELOP"
--
dna = parseDNA seq
--
-- LOCN 50 250 true
-- STYLE hide
--
displayDNA dna
--
-- LOCN 50 400 true
-- STYLE 
--
displayDNA' dna
--
-- LOCN 275 400 true
-- STYLE 
--
showDNA dna
--
-- LOCN 50 300 true
-- STYLE 
{-
Code of life
-}
-- LOCN 48 1227 true
-- STYLE heading1
{-
data Amino 
  = Ala | Arg | Asn | Asp | Cys | Gln | Glu | Gly | His | Ile
  | Leu | Lys | Met | Phe | Pro | Ser | Thr | Trp | Tyr | Val;

-}
-- LOCN 50 1275 true
-- STYLE commentM
--
showAmino Phe
--
-- LOCN 50 1375 true
-- STYLE 
--
encode (A, A, T)
--
-- LOCN 50 1450 true
-- STYLE 
--
encode (T, A, G)
--
-- LOCN 275 1450 true
-- STYLE 
--
transcription = transcribe dna
--
-- LOCN 50 1775 true
-- STYLE 
--
displayTranscript transcription
--
-- LOCN 275 1850 true
-- STYLE 
{-
transcribe :: DNA -> Transcript
-}
-- LOCN 50 1725 true
-- STYLE commentM
{-
type Junk = [Base];

type Aminos = [Amino];

data Transcript = Transcript [Either Junk Aminos];
-}
-- LOCN 50 1600 true
-- STYLE commentM
{-
START   =  ATG
STOP    =  TAA | TAG | TGA
-}
-- LOCN 600 2000 true
-- STYLE comment
{-
Back to previous document
-}
-- LOCN 25 3425 true
-- STYLE open1 ""
--
displayDNA dna
--
-- LOCN 50 1850 true
-- STYLE 
{-
Direct manipulation
-}
-- LOCN 50 2550 true
-- STYLE heading1
--
dna2 = parseDNA seq
--
-- LOCN 50 2675 true
-- STYLE 
--
scale 0.6 (displayDNA dna)
--
-- LOCN 500 400 true
-- STYLE 
{-
instance Edit DNA where {

  style dna = View displayAnnotDNA Picture;

  edit dna path = [("Delete base",  deleteFn),
                   ("Insert a gap", insertFn),
                   ("Set to A",     setToFn "A"),
                   ("Set to C",     setToFn "C"),
                   ("Set to G",     setToFn "G"),
                   ("Set to T",     setToFn "T"),
                   ("Unset",        setToFn "X"),
                   ("Evaluate",     evaluateFn)]
}
-}
-- LOCN 475 2575 true
-- STYLE commentM
{-
Exercise:  Modify and extend the above instance of the Edit class so as to
allow the user to carry out direct manipulation of the righthand side of this kind of 
diagram. This would allow the user to work at a higher level of abstraction
when designing DNA molecules. It could, for example, allow the user to select
the codon that codes for "Threonine"  and specify that it should be replaced with
one that codes for "Isoleucine".
-}
-- LOCN 475 2925 true
-- STYLE comment
{-
Experimenting with SNPs
-}
-- LOCN 25 3375 true
-- STYLE open "DNA_SNIP"
